
****
     SUBROUTINE PLUT89(NAME,X,XO,RADI,INCL,ILAB,ITYPE,IC,XP,YP,ZP,RP,
    *           MOL,XL,YL,XPS,YPS,RPS,XRAT,YRAT,RAT,RATY,IDONE,
    *           IFIX,INEXT,IOBSC,NSZ1,NSZ2,NSZ3)
****
**** Pluto : Sam Motherwell
**** Mark II Version : Bill Clegg
**** Modified for FORTRAN77 S.Gorter, Leiden, Netherlands
**** Declarations
****
     COMMON /AAA   / NAT,NATOS,NATO,NC,NC1,IERR,IPLOT
     COMMON /BBB   / IBS(30,3),R(3,3),NMOL,NSPEC,NATOT,ICELL,
    *                ISTER,IPERS,ISOL,TAPER,ITRACE,ICOPY,IPLOTR,CHSIZE,
    *                SIZEM,SCA,DPLOT,S,ITRACH,ITRACV,TRLAB,ISHADE,ANG1,
    *                ANG2,SHADEN,PLSTEP,TRSTEP,IEND,SHRINK,YLIM,TSIZE,
    *                NMOL1
     COMMON /BBBC  / ID(74)
     COMMON /CELL  / ACELL,BCELL,CCELL,ALF,BET,GAM,OR1,OR2,OR3,OR4,
    *                OR5,OR6,D100,D010,D001
     COMMON /SYM   / RS(24,3,4),NSYM,ICENT
     COMMON /DEF   / RBDEF,LBDEF,RADEF,SZDEF,CHDEF,DPDEF,TDEF,RBDEFN,
    *                LBDEFN,ANGDF1,ANGDF2,SHADEF,TAPDEF,TLDEF,
    *                TRDEF,PLDEF
     COMMON /FRC   / COL(80),FL(6,40)
     COMMON /FRN   / FN(40),NCHAR,KN,KL
     COMMON /EEE   / IENC,ENC(6)
     COMMON /XLIMIT/ XMAX,YMAX,XMIN,YMIN
     COMMON /IO    / IN
****
     CHARACTER FL,COL,NAME,ID,IDT*72,NAMX*6
****
     DIMENSION NAME(6,NSZ1),X(3,NSZ1),XO(3,NSZ1),RADI(NSZ1)
     DIMENSION INCL(NSZ1),ILAB(NSZ1),ITYPE(NSZ1),IC(NSZ2)
     DIMENSION XP(NSZ3),YP(NSZ3),ZP(NSZ3),RP(NSZ3),MOL(4,NSZ3)
     DIMENSION XL(NSZ1),YL(NSZ1),XPS(NSZ1),YPS(NSZ1),RPS(NSZ1)
     DIMENSION XRAT(NSZ1),YRAT(NSZ1),RAT(NSZ1),RATY(NSZ1)
     DIMENSION IDONE(NSZ1),IFIX(NSZ1),INEXT(NSZ1),IOBSC(NSZ1)
****
     IN=10
     NPLOT=0
     IBEGIN=0
     WRITE(6,4000)
     CALL INPUT(5,IN,9,500)
     CALL MSSGE(12)
****
**** Initialise
****
     NCHAR=6
     NPL=0
     READ(3,1000)NPLOT
     IPLOT=0
     ICOUNT=1
     XR=0.
     YR=0.
     ZR=0.
     CALL ZSETUP(YLIM,DEYE,RATIO,NPLOT)
****
**** Read and interpret input up to first plot instruction
****
   1 CALL INTERP(ICOUNT,NAME,X,XO,RADI,INCL,ILAB,ITYPE,IC,XP,YP,ZP,RP,
    *   MOL,IDONE,IFIX,INEXT,NSZ1,NSZ2,NSZ3,IBEGIN)
****
**** Test for end-of-job
****
     IF(FL(1,1).EQ.'=')GO TO 51
****
**** Initialise for plotting
****
     NPL=NPL+1
     WRITE(6,2)NPL
     NCOPY=0
     PMAX=-1.0E10
     PMIN=1.0E10
     XMAX=PMAX
     YMAX=PMAX
     XMIN=PMIN
     YMIN=PMIN
     WRITE(6,4)((R(I,J),J=1,3),I=1,3)
     R11=R(1,1)
     R12=R(1,2)
     R13=R(1,3)
     R21=R(2,1)
     R22=R(2,2)
     R23=R(2,3)
     R31=R(3,1)
     R32=R(3,2)
     R33=R(3,3)
     NAP=0
     XR=0.
     YR=0.
     ZR=0.
     IF(NMOL.GT.0)GO TO 5
     MOL(1,1)=1
     MOL(2,1)=0
     MOL(3,1)=0
     MOL(4,1)=0
     NMOL=1
****
**** Build up array of plot coords.
**** Begin loop on molecule list
****
   5 DO 11 M=1,NMOL
        NA=MOL(1,M)
        N=IABS(NA)
        TX=FLOAT(MOL(2,M))
        TY=FLOAT(MOL(3,M))
        TZ=FLOAT(MOL(4,M))
        I1=9
        IF(M.EQ.1)I1=1
****
****    Begin loop on atoms in molecule
****
        DO 10 I=I1,NAT
****
****       Generate fractional coords first xf,yf,zf
****
           IOMIT=1
           IF(I.GE.9)GO TO 6
           XF=X(1,I)
           YF=X(2,I)
           ZF=X(3,I)
           GO TO 7
****
   6       CONTINUE
           XX=X(1,I)
           YY=X(2,I)
           ZZ=X(3,I)
           ZF=RS(N,3,1)*XX+RS(N,3,2)*YY+RS(N,3,3)*ZZ+RS(N,3,4)+TZ
           YF=RS(N,2,1)*XX+RS(N,2,2)*YY+RS(N,2,3)*ZZ+RS(N,2,4)+TY
           XF=RS(N,1,1)*XX+RS(N,1,2)*YY+RS(N,1,3)*ZZ+RS(N,1,4)+TX
           IF(NA.GT.0)GO TO 7
           ZF=-ZF+TZ+TZ
           YF=-YF+TY+TY
           XF=-XF+TX+TX
****
****       Test for atom outside enclosure for plot
****
   7       IF(IENC.EQ.0)GO TO 8
           IF(I.LE.8)GO TO 8
           IF(XF.LT.ENC(1).OR.XF.GT.ENC(2))GO TO 9
           IF(YF.LT.ENC(3).OR.YF.GT.ENC(4))GO TO 9
           IF(ZF.LT.ENC(5).OR.ZF.GT.ENC(6))GO TO 9
****
****       Make orthonormal
****
   8       IOMIT=0
           XOR=OR1*XF
           YOR=OR2*XF+OR3*YF
           ZOR=OR4*XF+OR5*YF+OR6*ZF
****
****       Rotate the orthonormal  coords
****
           XR=R11*XOR+R12*YOR+R13*ZOR
           YR=R21*XOR+R22*YOR+R23*ZOR
           ZR=R31*XOR+R32*YOR+R33*ZOR
           IF(ICELL.EQ.0.AND.I.LT.9)GO TO 9
           IF(INCL(I).LE.0.AND.I.LE.NATO)GO TO 9
           XMAX=AMAX1(XR,XMAX)
           YMAX=AMAX1(YR,YMAX)
           XMIN=AMIN1(XR,XMIN)
           YMIN=AMIN1(YR,YMIN)
   9       NAP=NAP+1
           IF(NAP.GT.NSZ3)GO TO 12
           XP(NAP)=XR
           YP(NAP)=YR
           ZP(NAP)=ZR
           RP(NAP)=RADI(I)
           IF(IOMIT.EQ.1)RP(NAP)=-1.
  10    CONTINUE
****
****    End of loop on atoms
****
  11 CONTINUE
****
**** End of loop on molecules
****
     GO TO 14
****
  12 WRITE(6,13)
     NPL=NPL-1
     GO TO 1
****
  14 NATOT=NAP
****
**** Get all coords referred to centre of the plot as origin.
****
     XC=(XMIN+XMAX)*0.5
     YC=(YMIN+YMAX)*0.5
     XMAX=XMAX-XC
     XMIN=XMIN-XC
     YMAX=YMAX-YC
     YMIN=YMIN-YC
     DO 15 I=1,NATOT
        XP(I)=XP(I)-XC
        YP(I)=YP(I)-YC
  15 CONTINUE
****
**** Get max and min for plot boundaries allowing a safety margin.
****
     PMAX=AMAX1(XMAX,YMAX)
     PMIN=AMIN1(XMIN,YMIN)
     RMAX=0.0
     IBOX=0
     DO 16 I=1,NAT
        IF(INCL(I).LE.0)GO TO 16
        RMAX=AMAX1(RMAX,RADI(I))
  16 CONTINUE
     PMAX=PMAX+RMAX
     PMIN=PMIN-RMAX
     SIZEA=PMAX-PMIN
     IF(SCA.LT.0.001)GO TO 17
****
**** Apply scale factor given .  ( sca mm/Angstrom)
****
     SIZEM=SIZEA*SCA
     S=SCA
     GO TO 18
****
**** Calculate scale factor to fit drawing in box of side sizem mm.
****
  17 IF(ABS(SIZEM).LE.1.0E-06)SIZEM=YLIM-5.1-TSIZE
     S=SIZEM/SIZEA
****
**** Scale down by factor 0.99 for safety and by factor provided if box
**** to be drawn
****
     S=S*0.99
  18 IF(ABS(SHRINK).LE.1.0E-06)GO TO 19
     IBOX=1
     S=S*SHRINK
  19 DPL=DPLOT
     IF(ISTER.EQ.0.AND.IPERS.EQ.0)DPL=10000.
     YMIN=3.
     YMAX=SIZEM+3.
     WRITE(6,20)SIZEA,SIZEM,S,DPL
     XX=XMAX+2.+TSIZE
     IF(XX.LT.SZDEF)GO TO 22
     WRITE(6,21)XX,SZDEF
     NPL=NPL-1
     GO TO 1
****
**** Convert coords to mm
****
  22 PMAX=SIZEM*0.5
     PMIN=-PMAX
     DO 23 I=1,NATOT
        IF(RP(I).LT.0.)GO TO 23
        XP(I)=XP(I)*S
        YP(I)=YP(I)*S
        ZP(I)=ZP(I)*S
        RP(I)=S*RP(I)*DPL/(DPL-ZP(I))
        IF(ISOL.EQ.0)RP(I)=0.
  23 CONTINUE
  24 IF(NCOPY.EQ.0)GO TO 28
****
**** Reset coordinates for multiple copy
****
     DO 27 I=1,NATOT
        XP(I)=XP(I)-PMAX
        YP(I)=YP(I)-PMAX-3.0
        IF(ISTER.EQ.0.AND.IPERS.EQ.0)GO TO 27
        Q=DPL/(DPL-ZP(I))
        YP(I)=YP(I)/Q
        IF(ISTER.EQ.0)GO TO 26
        IF(IPLOTR.NE.4)XP(I)=XP(I)-SIZEM
        XP(I)=(XP(I)-DEYE)/Q+DEYE
        GO TO 27
****
  26    XP(I)=XP(I)/Q
  27 CONTINUE
****
**** Set up pen
****
  28 CONTINUE
     I=1
     IF(IPLOTR.EQ.4.AND.ISTER.EQ.1)CALL ZSETPN(I)
     I=2
     IF(IPLOTR.EQ.4.AND.ISTER.EQ.2)CALL ZSETPN(I)
     IF(ISTER.EQ.0.AND.IPERS.EQ.0)GO TO 32
****
**** If stereo or perspective required adjust co-ordinates.
****
     DO 31 I=1,NATOT
        Q=DPL/(DPL-ZP(I))
        IF(ISTER.EQ.0)GO TO 30
        IF(ISTER.EQ.2)GO TO 29
****
****    Stereo coords for left eye view
****
        XP(I)=(XP(I)+DEYE)*Q-DEYE
        YP(I)=YP(I)*Q
        GO TO 31
****
****    Stereo coords for right eye view
****
  29    XP(I)=(XP(I)-PMAX+DEYE)/Q-DEYE
        XP(I)=(XP(I)-DEYE)*Q+DEYE
        GO TO 31
****
****    Perspective only
****
  30    XP(I)=XP(I)*Q
        YP(I)=YP(I)*Q
  31 CONTINUE
****
**** Get coords for atom labels here
****
  32 IF(ISTER.EQ.2)GO TO 33
     IF(NCOPY.GT.0)GO TO 33
     SC=S*RBDEF
     IF(ISOL.EQ.0)SC=.7
     CALL BELLA(RATIO,PMAX,PMIN,SC,NAME,INCL,ILAB,IC,XP,YP,RP,XL,
    *   YL,XPS,YPS,RPS,XRAT,YRAT,RAT,RATY,NSZ1,NSZ2,NSZ3)
****
**** Adjust coords by origin shift so that all are in range 0 - sizem
****
  33 IF(ISTER-1)34,34,35
  34 TX=PMAX
     TY=PMAX+3.0
     GO TO 36
****
  35 TX=PMAX+SIZEM
     IF(IPLOTR.EQ.4)TX=PMAX
     TY=0.
  36 DO 37 I=1,NATOT
        XP(I)=XP(I)+TX
        YP(I)=YP(I)+TY
  37 CONTINUE
     XMAX=PMAX+TX
     XMIN=PMIN+TX
****
**** Plot title
****
     YY=YMIN+5.0
     I=1
     XX=XMIN+5.0
     CALL ZDRAW(I,XX,YY)
     I=74
     REWIND 4
     WRITE(4,100)ID
     REWIND 4
     READ(4,101)IDT
     CALL ZWRITE(IDT,72,TSIZE)
     IF(IBOX.EQ.0)GO TO 38
****
**** Draw box defining the limit of plotting coords
****
     I=1
     CALL ZDRAW(I,XMIN,YMIN)
     I=2
     CALL ZDRAW(I,XMIN,YMAX)
     CALL ZDRAW(I,XMAX,YMAX)
     CALL ZDRAW(I,XMAX,YMIN)
     CALL ZDRAW(I,XMIN,YMIN)
****
**** Pass control to subr. solid for plotting circles and bonds
****
  38 CALL SOLID(NAME,INCL,ITYPE,IC,XP,YP,ZP,RP,IOBSC,NSZ1,NSZ2,NSZ3)
****
**** Labels plotted here
****
     IF(ISTER.EQ.2)GO TO 43
     DO 42 I=1,NAT
        IF(I.LT.9.AND.ICELL.EQ.0)GO TO 42
        IF(ILAB(I).EQ.0)GO TO 42
        IF(I.GE.9.AND.I.LE.NATO.AND.INCL(I).LE.0)GO TO 42
        IF(RP(I).LT.0.)GO TO 42
        XLABL=XL(I)+PMAX
        XX=FLOAT(ITRACV)*TRLAB
        YLABL=YL(I)+PMAX+3.+XX*0.5+TRLAB
        XLABL=XLABL-FLOAT(ITRACH-1)*0.5*TRLAB
        DO 41 K=1,ITRACH
           YLABL=YLABL-XX
           DO 40 L=1,ITRACV
              J=1
              CALL ZDRAW(J,XLABL,YLABL)
              REWIND 4
              WRITE(4,102)(NAME(J,I),J=1,6)
              REWIND 4
              READ(4,103)NAMX
              CALL ZWRITE(NAMX,6,CHSIZE)
              YLABL=YLABL+TRLAB
  40       CONTINUE
           XLABL=XLABL+TRLAB
  41    CONTINUE
  42 CONTINUE
****
**** Test if stereo pair is to be drawn
****
  43 IF(ISTER.EQ.0)GO TO 45
     ISTER=ISTER+1
     IF(ISTER.GT.2)GO TO 44
     GO TO 28
****
  44 ISTER=1
****
**** Control of number of copies
****
  45 NCOPY=NCOPY+1
     CALL ZENDER(0,IPLOT,IBEGIN)
     WRITE(6,46)NPL,NCOPY
     IF(NCOPY.LT.ICOPY)GO TO 24
     GO TO 1
****
**** End of job
****
  51 CONTINUE
     CALL ZENDER(-1,IPLOT,IBEGIN)
     CALL ROUTE(0,0,1,ier)
     WRITE(6,4001)
     IF(NPLOT.NE.0)STOP 4
     STOP
****
   2 FORMAT('0*** Begin of plot nr',I5,/,
    *       '+_________________________',/)
   4 FORMAT('0View rotation matrix'/3('0',9X,3F10.5/),'0')
  13 FORMAT('0*** Plot coord lists full: Too many atoms in plot',//)
  20 FORMAT('0Size of plotting area =',F8.2,' Angstroms =',F8.2,
    *       ' mm.  Scale factor =', F8.4,' mm/A',/
    *       '0nerspective distance =',F10.1,' mm')
  21 FORMAT('0*** Plot plus title requires width of',F8.2,
    *       'mm.  Maximum permitted is',F8.2,'mm.  Plot abandonned.',
    *       //)
  46 FORMAT('0Completed drawing no.',I3,' - Copy no.',I3,/,
    *       '+______________________________________')
 100 FORMAT(74A1)
 101 FORMAT(A72)
 102 FORMAT(6A1)
 103 FORMAT(A6)
1000 FORMAT(I5)
4000 FORMAT('0',30X,
    *       '***   P L U T O  Program  ***'//,
    *       37X,'Plotting of structures'//,
    *       37X,'Author      : S. Motherwell'//,
    *       37X,'Date        : December 7, 1992 - Service version'//,
    *       37X,'Inquiries   : S.Gorter (ASKASG@HLERUL2)'//,
    *       ' ',32('****'),//)
4001 FORMAT(//,' ',11('****'),'**    E N D   O F   P R O G R A M   **',
    *       11('****'))
****
     END
****
     SUBROUTINE BELLA(RATIO,PMAX,PMIN,SC,NAME,INCL,ILAB,IC,XP,YP,RP,
    *           XL,YL,XPS,YPS,RPS,XRAT,YRAT,RAT,RATY,NSZ1,NSZ2,NSZ3)
****
**** This routine finds positions for atom labels ( minimum overlap)
**** The coord of bottom l.h. corner of label are xlabl,ylabl.
****
     COMMON /AAA   / NAT,NATOS,NATO,NC,NC1,IERR,IPLOT
     COMMON /BBB   / IBS(30,3),R(3,3),NMOL,NSPEC,NATOT,ICELL,
    *                ISTER,IPERS,ISOL,TAPER,ITRACE,ICOPY,IPLOTR,CHSIZE,
    *                SIZEM,SCA,DPLOT,S,ITRACH,ITRACV,TRLAB,ISHADE,ANG1,
    *                ANG2,SHADEN,PLSTEP,TRSTEP,IEND,SHRINK,YLIM,
    *                TSIZE,NMOL1
****
     CHARACTER NAME
****
     DIMENSION NAME(6,NSZ1),INCL(NSZ1),ILAB(NSZ1),IC(NSZ2),
    *          XP(NSZ3),YP(NSZ3),RP(NSZ3),XL(NSZ1),YL(NSZ1),
    *          XPS(NSZ1),YPS(NSZ1),RPS(NSZ1),XRAT(NSZ1),YRAT(NSZ1),
    *          RAT(NSZ1),RATY(NSZ1),SUM(8),XLAB(8),YLAB(8)
****
     NMAX=NSZ1
     NAB=NAT-8
     NATL=NATOT
     HEIGHT=CHSIZE
     WIDTH=CHSIZE*RATIO
     PLMAX=PMAX-HEIGHT
     PLMIN=PMIN+HEIGHT
     NT=1
   1 DO 25 I=1,NAT
        IF(ILAB(I).EQ.0)GO TO 25
        IF(I.LT.9.AND.ICELL.EQ.0)GO TO  25
        IF(RP(I).LT.0.)GO TO 25
        IF(INCL(I).LE.0.AND.I.LE.NATO.AND.I.GT.8)GO TO 25
        MAXTRY=8
        XI=XP(I)
        YI=YP(I)
        RI=RP(I)
****
****    Add 1mm to the atom radius to allow a small gap.
****
        RI=RI+1.
        SS=AMIN1(SC,RI)
****
****    Set a distance to scan for atoms which may intersect with label
****    find width of label
****
        DO 2 K=1,6
           IF(NAME(K,I).EQ.' ')GO TO 3
   2    CONTINUE
        K=7
   3    W=FLOAT(K-1)*WIDTH
****
****    W is the width of the label in mm. We now set a distance
****    for scanning for possible intersecting atoms with this label.
****
        D1=RI+W+WIDTH
        D2=RI+2.*HEIGHT
        W2=0.5*W
        H2=0.5*HEIGHT
        R2=RI*0.7071
****
****    Set up the coords of the centres of label positions.
****
        XLAB(1)=RI+W2
        YLAB(1)=0.0
        XLAB(2)=R2+W2
        YLAB(2)=R2+H2
        XLAB(3)=0.0
        YLAB(3)=RI+H2
        XLAB(4)=-XLAB(2)
        YLAB(4)=YLAB(2)
        XLAB(5)=-XLAB(1)
        YLAB(5)=0.
        XLAB(6)=-XLAB(2)
        YLAB(6)=-YLAB(2)
        XLAB(7)=0.
        YLAB(7)=-YLAB(3)
        XLAB(8)=-XLAB(4)
        YLAB(8)=-YLAB(4)
        DO 4 K=1,8
           XLAB(K)=XLAB(K)+XI
           YLAB(K)=YLAB(K)+YI
   4    CONTINUE
        IF(NT.EQ.0)GO TO 5
        M=ILAB(I)-1
        IF(M.EQ.0)GO TO 25
        X1=XLAB(M)-W2
        X2=XLAB(M)+W2
        Y1=YLAB(M)-H2
        Y2=YLAB(M)+H2
        GO TO 17
****
****    Make a list of atoms lying within the range (x1...x2, y1...y2)
****    This defines a rectangle  around the atom
****
   5    IF(ILAB(I).GT.1)GO TO 25
        X1=XI-D1
        X2=XI+D1
        Y1=YI-D2
        Y2=YI+D2
        NRAT=0
        DO 8 J=1,NATL
           IF(J.GT.NATOT)GO TO 6
           IF(I.EQ.J)GO TO 8
           JO=MOD(J-9,NAB)+9
           IF(INCL(JO).LE.0)GO TO 8
           IF(RP(J).LT.0.)GO TO 8
           XJ=XP(J)
           YJ=YP(J)
           RJ=RP(J)
           RJJ=RJ
           GO TO 7
****
   6       K=J-NATOT
           XJ=XPS(K)
           YJ=YPS(K)
           RJ=RPS(K)
           RJJ=H2
   7       IF(XJ.GT.X2+RJ)GO TO 8
           IF(XJ.LT.X1-RJ)GO TO 8
           IF(YJ.GT.Y2+RJJ)GO TO 8
           IF(YJ.LT.Y1-RJJ)GO TO 8
           DX=XJ-XI
           DY=YJ-YI
           IF(DX*DX+DY*DY.LT.0.01)GO TO 8
           NRAT=NRAT+1
           IF(NRAT.GT.NMAX)GO TO 22
           XRAT(NRAT)=XJ
           YRAT(NRAT)=YJ
           RAT(NRAT)=RJ
           RATY(NRAT)=RJJ
   8    CONTINUE
****
****    Add dummy 'atom centres' at points where bonds to atom i
****    intersect circle
****
        DIN=RI
        DO 11 K=1,NC
           IO=IC(K)/1000
           JO=MOD(IC(K),1000)
           IF(IO.EQ.I)GO TO 10
           IF(JO.EQ.I)GO TO 9
           GO TO 11
****
   9       M=JO
           JO=IO
           IO=M
  10       CONTINUE
           DX=XP(JO)-XP(IO)
           DY=YP(JO)-YP(IO)
           DSQ=DX*DX+DY*DY
           IF(DSQ.LT.0.001)GO TO 11
           DIJ=SQRT(DSQ)
           NRAT=NRAT+1
           IF(NRAT.GT.NMAX)GO TO 22
           XRAT(NRAT)=XI+DIN*DX/DIJ
           YRAT(NRAT)=YI+DIN*DY/DIJ
           RAT(NRAT)=SS
           RATY(NRAT)=SS
  11    CONTINUE
****
****    Examine label positions 1 to 8. Get the distance from the label
****    centre to the selected nrat atoms.
****    Form a sum of 1/d**2
****
        IF(NRAT.EQ.0)NRAT=1
        DO 12 K=1,8
           SUM(K)=0.
           DO 122 J=1,NRAT
              DX=XRAT(J)-XLAB(K)
              DY=YRAT(J)-YLAB(K)
              DSQ=DX*DX+DY*DY
              DSQ=AMAX1(DSQ,.00001)
              SUM(K)=SUM(K)+1.0/DSQ
 122       CONTINUE
  12    CONTINUE
        ITRY=1
****
****    Find the position giving lowest sum.
****
  13    DS=1.0E10
        DO 14 K=1,8
           IF(SUM(K).GT.DS)GO TO 14
           M=K
           DS=SUM(K)
  14    CONTINUE
        IF(ITRY.EQ.1)M1=M
****
****    Test for intersection of this label with the rats
****
        X1=XLAB(M)-W2
        X2=XLAB(M)+W2
        Y1=YLAB(M)-H2
        Y2=YLAB(M)+H2
        DO 16 J=1,NRAT
           XJ=XRAT(J)
           YJ=YRAT(J)
           RJ=RAT(J)
           RJJ=RATY(J)
           IF(XJ.GT.X2+RJ)GO TO 16
           IF(XJ.LT.X1-RJ)GO TO 16
           IF(YJ.GT.Y2+RJJ)GO TO 16
           IF(YJ.LT.Y1-RJJ)GO TO 16
****
****       Reject this position as we have an intersection.
****
           SUM(M)=1.0E10
           ITRY=ITRY+1
           IF(ITRY.LE.MAXTRY)GO TO 13
           WRITE(6,15)(NAME(K,I),K=1,6)
           M=M1
           X1=XLAB(M1)-W2
           Y1=YLAB(M1)-H2
           GO TO 18
****
  16    CONTINUE
****
****    Test for label position outside permitted plot range
****
  17    IF(X1.LT.PLMIN.OR.X2.GT.PLMAX.OR.Y1.LT.PLMIN.OR.
    *      Y2.GT.PLMAX)GO TO 19
  18    XLABL=X1
        YLABL=Y1
****
****    Add this label coordinates to the atom list
****
        NATL=NATL+1
        K=NATL-NATOT
        XPS(K)=XLAB(M)
        YPS(K)=YLAB(M)
        RPS(K)=W2
        GO TO 24
****
**** Reject out-of-bounds label position
****
  19    IF(NT.EQ.0)GO TO 21
        WRITE(6,20)(NAME(K,I),K=1,6)
        ILAB(I)=1
        GO TO 25
****
  21    SUM(M)=2.0E10
        ITRY=1
        MAXTRY=MAXTRY-1
        GO TO 13
****
  22    WRITE(6,23) NMAX,(NAME(K,I),K=1,6)
        XLABL=XI+RI
        YLABL=YI
  24    XL(I)=XLABL
        YL(I)=YLABL
  25 CONTINUE
     IF(NT.EQ.0)GO TO 26
     NT=0
     GO TO 1
****
  26 DO 27 I=1,NAT
        ILAB(I)=MIN0(ILAB(I),1)
  27 CONTINUE
     RETURN
****
  15 FORMAT(' *** Label positioning problem...',6A1,//)
  20 FORMAT(' *** Selected position for label ',6A1,
    *       ' is out of bounds. Label will be placed by automatic',
    *       ' routine',//)
  23 FORMAT(' *** More than',I4,' atoms in label posn calc list...',
    *        6A1,//)
****
     END
****
     SUBROUTINE SOLID(NAME,INCL,ITYPE,IC,XP,YP,ZP,RP,IOBSC,NSZ1,NSZ2,
    *           NSZ3)
****
**** Controls plotting of atoms and bonds
**** Declarations
****
     COMMON /AAA   / NAT,NATOS,NATO,NC,NC1,IERR,IPLOT
     COMMON /BBB   / IBS(30,3),R(3,3),NMOL,NSPEC,NATOT,ICELL,
    *                ISTER,IPERS,ISOL,TAPER,ITRACE,ICOPY,IPLOTR,CHSIZE,
    *                SIZEM,SCA,DPLOT,S,ITRACH,ITRACV,TRLAB,ISHADE,ANG1,
    *                ANG2,SHADEN,PLSTEP,TRSTEP,IEND,SHRINK,YLIM,TSIZE,
    *                NMOL1
     COMMON /DEF   / RBDEF,LBDEF,RADEF,SZDEF,CHDEF,DPDEF,TDEF,RBDEFN,
    *                LBDEFN,ANGDF1,ANGDF2,SHADEF,TAPDEF,TLDEF,TRDEF,
    *                PLDEF
****
     CHARACTER NAME
****
     DIMENSION NAME(6,NSZ1),INCL(NSZ1),ITYPE(NSZ1),IC(NSZ2),
    *          XP(NSZ3),YP(NSZ3),ZP(NSZ3),RP(NSZ3),IOBSC(NSZ1)
****
**** Decide whether solid or stick
****
     IF(ISOL.EQ.0)GO TO 7
     NAB=NAT-8
****
**** Plot circles
**** Begin loop on all atoms in plot arrays
****
     DO 6 I=9,NATOT
        IF(RP(I).LT.0.)GO TO 6
        IO=MOD(I-9,NAB)+9
        IF(INCL(IO).LE.0)GO TO 6
        IF(INCL(IO).GE.100.AND.IO.NE.I)THEN
****
****       Tests to avoid drawing an atom more than once
****
           J=I-NAB
           DO 1 L=IO,J,NAB
              IF(ABS(XP(L)-XP(I)).GT.0.1)GO TO 1
              IF(ABS(YP(L)-YP(I)).GT.0.1)GO TO 1
              IF(ABS(ZP(L)-ZP(I)).GT.0.1)GO TO 1
              GO TO 6
****
   1       CONTINUE
        ENDIF
        L=1
        XI=XP(I)
        YI=YP(I)
        ZI=ZP(I)
        RI=RP(I)
        IF(RI.LT.0.1)GO TO 6
****
****    Get list of atoms j which obscure atom I.  This allows for
****    intersection of spheres in van der waals models.
****
        DO 3 J=9,NATOT
           IF(RP(J).LT.0.)GO TO 3
           JO=MOD(J-9,NAB)+9
           IF(INCL(JO).LE.0)GO TO 3
           IF(J.EQ.I)GO TO 3
           IF(ZP(J)+RP(J).LT.ZI)GO TO 3
           RIJ=RI+RP(J)
           XJ=XP(J)
           DX=XJ-XI
           IF(ABS(DX).GT.RIJ)GO TO 3
           YJ=YP(J)
           DY=YJ-YI
           IF(ABS(DY).GT.RIJ)GO TO 3
           DIJSQ=DX*DX+DY*DY
           RIJSQ=RIJ*RIJ
           IF(DIJSQ.GT.RIJSQ)GO TO 3
****
****       Envelope circles intersect in projn down zp - test now for
****       sphere intersection.
****
           NJ=J
           DZ=ZP(J)-ZP(I)
           DIJSQ=DIJSQ+DZ*DZ
****
****       Remove atoms which have identical coords to atom i.
****       Intersecting spheres are marked with negative j.
****
           IF(DIJSQ.LT.0.1)GO TO 3
           IF(DIJSQ.LT.RIJSQ)NJ=-J
****
****       Enter this atom j in the obscuring list.
****
           IOBSC(L)=NJ
           L=L+1
           IF(L.GT.NSZ1)GO TO 4
   3    CONTINUE
   4    IF(L.GT.NSZ1)WRITE(6,5)NSZ1,(NAME(K,I),K=1,6)
        NOBSC=L-1
****
****    Now we can draw the circle for atom i
****
        CALL CIRCO(I,XP,YP,ZP,RP,NOBSC,ISHADE,ANG1,ANG2,DPLOT,SHADEN,
    *      PLSTEP,TRSTEP,ITRACE,IOBSC,NSZ1)
   6 CONTINUE
****
**** End of loop on atoms
**** Plotting of bonds
****
   7 IF(NC.LE.12.AND.ICELL.EQ.0)GO TO 31
****
**** Begin loop on molecules
****
     NJ=NAT-8
     MM=0
     DO 30 M=1,NMOL
        I1=13
        IF(M.EQ.1.AND.ICELL.EQ.1)I1=1
****
****    Loop through the list of connections stored in array ic
****
        DO 29 II=I1,NC
           IO=IC(II)/1000
           JO=MOD(IC(II),1000)
****
****       Omit intramolecular bonds when either atom is omitted,
****       incl<=0
****
           IF(IO.LT.9.OR.IO.GT.NATO.OR.JO.LT.9.OR.JO.GT.NATO)GO TO 8
           IF(INCL(IO).LE.0.OR.INCL(JO).LE.0)GO TO 29
   8       I=IO+MM
           J=JO+MM
           IF(RP(I).LT.0..OR.RP(J).LT.0.)GO TO 29
           IF(ISOL.EQ.0)GO TO 28
           IF(M.EQ.1)GO TO 15
****
****       Tests to avoid drawing a bond more than once
****
           N1=IABS(INCL(IO))
           N2=IABS(INCL(JO))
           IF(N1+N2.EQ.2)GO TO 15
           K1=MOD(N1,100)
           K2=MOD(N2,100)
           IF(N1.GT.100.OR.N2.GT.100)GO TO 9
           K=JO
           L=IO
           GO TO 10
****
   9       K=IO
           L=JO
           IF(K2.NE.1)L=K2
           IF(K1.NE.1)K=K1
  10       K1=1000*MIN0(K,L)+MAX0(K,L)
           DO 11 N2=13,NC
              IF(K1.EQ.IC(N2))GO TO 12
  11       CONTINUE
           GO TO 15
****
  12       XI=XP(I)
           YI=YP(I)
           ZI=ZP(I)
           XJ=XP(J)
           YJ=YP(J)
           ZJ=ZP(J)
           N1=M-1
           DO 14 N2=1,N1
              IF(ABS(XI-XP(K)).GT.0.1)GO TO 13
              IF(ABS(XJ-XP(L)).GT.0.1)GO TO 13
              IF(ABS(YI-YP(K)).GT.0.1)GO TO 13
              IF(ABS(YJ-YP(L)).GT.0.1)GO TO 13
              IF(ABS(ZI-ZP(K)).GT.0.1)GO TO 13
              IF(ABS(ZJ-ZP(L)).GT.0.1)GO TO 13
              GO TO 29
****
  13          K=K+NJ
              L=L+NJ
  14       CONTINUE
****
****       Skip this bond if spheres intersect
****
  15       DX=XP(I)-XP(J)
           DY=YP(I)-YP(J)
           DZ=ZP(I)-ZP(J)
           DIJSQ=DX*DX+DY*DY+DZ*DZ
           RIJ=RP(I)+RP(J)
           RIJSQ=RIJ*RIJ
           IF(DIJSQ.LE.RIJSQ)GO TO 270
           IF(ZP(I).GT.ZP(J))GO TO 16
           K=I
           I=J
           J=K
****
****       Now zp(i).gt.zp(j)
****       Allocate bond radius and number of lines.
****
  16       IF(I.LT.9)GO TO 21
           RBO=RBDEF
           NLI=LBDEF
           IF(NSPEC.EQ.0)GO TO 22
           L=-1
           DO 20 K=1,NSPEC
              N1=IBS(K,1)
              N2=IBS(K,2)
              N3=IBS(K,3)
              IF(N1)17,18,19
****
****          Intermolecular
****
  17          IF(IO.GT.NATOS.OR.JO.GT.NATOS)L=N3
              GO TO 20
****
****          Atom type
****
  18          IF(ITYPE(IO).EQ.N2.OR.ITYPE(JO).EQ.N2)L=N3
              IF(IO.EQ.N2.OR.JO.EQ.N2)L=N3
              GO TO 20
****
****          Specific bond
****
  19          IF((N1.EQ.IO.AND.N2.EQ.JO).OR.(N1.EQ.JO.AND.N2.EQ.IO))
    *            L=N3
  20       CONTINUE
           IF(L.EQ.-1)GO TO 22
           RBO=0.001*FLOAT(MOD(L,1000))
           NLI=L/1000
           GO TO 22
****
  21       RBO=0.
           NLI=1
  22       IF(NLI.EQ.0)GO TO 29
****
****       Scale bond radius to mm.
****
           RBO=RBO*S
****
****       Search begins for atoms k which obscure this bond (i-n)
****
           XI=XP(I)
           YI=YP(I)
           ZI=ZP(I)
           XN=XP(J)
           YN=YP(J)
           ZN=ZP(J)
           AX=XN-XI
           AY=YN-YI
           ASQ=AX*AX+AY*AY
           IF(ASQ.LT.0.01)GO TO 29
           L=1
           X1=AMIN1(XI,XN)
           X2=AMAX1(XI,XN)
           Y1=AMIN1(YI,YN)
           Y2=AMAX1(YI,YN)
           DO 25 K=9,NATOT
              IF(RP(K).LT.0.)GO TO 25
              KO=MOD(K-9,NAB)+9
              IF(INCL(KO).LE.0)GO TO 25
              IF(K.EQ.I.OR.K.EQ.J)GO TO 25
              IF(ZP(K).LT.ZN)GO TO 25
              RK=RP(K)
              XK=XP(K)
              XLO=X1-RK
              XHI=X2+RK
              IF(XK.LT.XLO.OR.XK.GT.XHI)GO TO 25
              YK=YP(K)
              YLO=Y1-RK
              YHI=Y2+RK
              IF(YK.LT.YLO.OR.YK.GT.YHI)GO TO 25
****
****          If we get this far we apply the exact test for
****          Intersection.
****
              BX=XK-XI
              BY=YK-YI
              BSQ=BX*BX+BY*BY
              ADOTB=AX*BX+AY*BY
              PERPSQ=BSQ-ADOTB*ADOTB/ASQ
              DD=RK+RBO
              IF(PERPSQ.GT.DD*DD)GO TO 25
              IF(ABS(XN-XK).GT.0.001)GO TO 23
              IF(ABS(YN-YK).GT.0.001)GO TO 23
              IF(ABS(ZN-ZP(K)).GT.0.001)GO TO 23
              GO TO 25
****
  23          IF(ABS(XI-XK).GT.0.001)GO TO 24
              IF(ABS(YI-YK).GT.0.001)GO TO 24
              IF(ABS(ZI-ZP(K)).GT.0.001)GO TO 24
              GO TO 25
****
****          This atom intersects the bond line i to n.
****
  24          IOBSC(L)=K
              L=L+1
              IF(L.GT.NSZ1)GO TO 26
  25       CONTINUE
  26       IF(L.GT.NSZ1)WRITE(6,27)NSZ1,I,J
           NOBSC=L-1
****
****       Now we can draw the bond i to n.
****
           CALL BONDIN(I,J,XP,YP,ZP,RP,NOBSC,TAPER,RBO,NLI,PLSTEP,
    *         DPLOT,XI,YI,XN,YN,IEND,IOBSC,NSZ1)
           GO TO 29
****
 270       IF(ISHADE.LT.3)GO TO 29
****
****       Stick bonds only---no circles - no obscuring
****
  28       L=1
           CALL ZDRAW(L,XP(I),YP(I))
           L=2
           CALL ZDRAW(L,XP(J),YP(J))
  29    CONTINUE
****
****    End of loop on connections
****
        MM=MM+NJ
  30 CONTINUE
****
**** End of loop on molecules
****
  31 RETURN
****
   5 FORMAT(' *** More than',I5,' atoms obscure',6A1,//)
  27 FORMAT(' *** More than ',I5,' Obscuring atoms for bond between',
    *' atoms',I5,' and',I5,//)
****
     END
****
     SUBROUTINE CIRCO(IATOM,XP,YP,ZP,RP,NOBSC,ISHADE,ANG1,ANG2,DPLOT,
    *           SHADEN,PLSTEP,TRSTEP,ITRACE,IOBSC,NSZ1)
****
     DIMENSION IOBSC(NSZ1)
****
     COMMON /SCRAT1/ U1(3),U2(3),U3(3),ZAX(3),DC(3),P(3),Q(3)
****
     DIMENSION XP(1),YP(1),ZP(1),RP(1)
****
     PI=3.14159
****
**** Draw the circle representing the sphere projected on xy plane.
**** Set up number of straight-line segments
****
     XCENT=XP(IATOM)
     YCENT=YP(IATOM)
     RADIUS=RP(IATOM)
     X=2.*PI*RADIUS/PLSTEP+1.
     IF(NOBSC.EQ.0)X=10.5*SQRT(RADIUS)
     M=INT(X)
     M=MAX0(M,10)
     DTH=2.0*PI/FLOAT(M)
     CX=COS(DTH)
     SX=SIN(DTH)
     CY=1.
     SY=0.
     NPP=M+1
****
**** Now plot the circle as the sequence of npp points
****
     NTRACE=0
     INS=0
     JIN=0
     IUP=1
     I=0
   1 I=I+1
     IF(I.GT.NPP)GO TO 8
     X=CY*RADIUS+XCENT
     Y=SY*RADIUS+YCENT
     IF(NOBSC.EQ.0)GO TO 6
     Z=ZP(IATOM)
****
**** This section tests for the obscuring of the point (x,y,z) by any
**** of the atoms given in the array iobsc. If there is intersection
**** of sphere, the negative is given of the atom serial number.
****
   2 DO 4  N=1,NOBSC
        J=IOBSC(N)
        J=IABS(J)
        DX=X-XP(J)
        RJ=RP(J)
        IF(ABS(DX).GT.RJ)GO TO 4
        DY=Y-YP(J)
        IF(ABS(DY).GT.RJ)GO TO 4
        DSQ=DX*DX+DY*DY
        RJSQ=RJ*RJ
****
****    Point is obscured when within envelope circle j and zj.gt.z
****
        IF(DSQ.LT.RJSQ.AND.ZP(J).GT.Z)GO TO 5
        IF(IOBSC(N))3,4,4
****
****    Point is obscured if within sphere j.
****
   3    IF(J.EQ.JIN)GO TO 4
        DZ=Z-ZP(J)
        DSQ=DSQ+DZ*DZ
        IF(DSQ.LT.RJSQ)GO TO 5
   4 CONTINUE
****
**** No obscuring so go ahead with plotting of this step.
****
     GO TO 6
****
**** An obscuring atom has been found .  lift the pen.
****
   5 IUP=1
     GO TO 7
****
**** Pen down and plot this step.
****
   6 J=2
     IF(IUP.EQ.1)J=1
     CALL ZDRAW(J,X,Y)
     IUP=0
****
**** Next point of circle
****
   7 X=CY*CX-SY*SX
     SY=SY*CX+CY*SX
     CY=X
     IF(INS)1,1,14
****
**** End of circle : retrace if requested
****
   8 IUP=1
     NTRACE=NTRACE+1
     I=0
     RADIUS=RADIUS-TRSTEP
     IF(NTRACE.LT.ITRACE)GO TO 1
****
**** Draw circles showing the section of overlap of spheres.
****
     INS=1
     RADIUS=RP(IATOM)
     IF(NOBSC.EQ.0)GO TO 16
     NN=1
   9 IF(IOBSC(NN))10,15,15
  10 J=-IOBSC(NN)
     ZAX(1)=0.
     ZAX(2)=0.
     ZAX(3)=1.
****
**** Tests to avoid drawing each intersection more than once
****
     IF(ZP(IATOM).LT.ZP(J))GO TO 15
     DX=XP(J)-XP(IATOM)
     DY=YP(J)-YP(IATOM)
     DZ=ZP(J)-ZP(IATOM)
****
**** Get the distance along line ij of the plane of the intersection.
**** This is calculated by simple cosine formula.
****
     DSQ=DX*DX+DY*DY+DZ*DZ
     DIJ=SQRT(DSQ)
     RI=RP(IATOM)
     RJ=RP(J)
     DIN=(RI*RI+DSQ-RJ*RJ)/(2.0*DIJ)
     RIN=RI*RI-DIN*DIN
     IF(RIN.LE.0)GO TO 15
     RIN=SQRT(RIN)
****
**** Direction cosines of vector ij
****
     U3(1)=DX/DIJ
     U3(2)=DY/DIJ
     U3(3)=DZ/DIJ
     XB=XP(IATOM)+U3(1)*DIN
     YB=YP(IATOM)+U3(2)*DIN
     ZB=ZP(IATOM)+U3(3)*DIN
****
**** The intersection circle has centre at (xb,yb,zb) and radius rin.
**** Set up axial system with u3 along direction ij. the circle is
**** generated as coordinates  (xx,yy,0)
****
     IF(ABS(U3(3)).LT.0.9999)GO TO 11
     U1(1)=1.
     U1(2)=0.
     U1(3)=0.
     GO TO 12
****
  11 CALL VPROD(ZAX,U3,U1)
  12 CALL VPROD(U3,U1,U2)
****
**** Calculate points on circle using theta from 0 to pi.
****
     JIN=J
     CY=1.
     SY=0.
     IP=1
  13 XX=CY*RIN
     YY=SY*RIN
     X=U1(1)*XX+U2(1)*YY+XB
     Y=U1(2)*XX+U2(2)*YY+YB
     Z=U1(3)*XX+U2(3)*YY+ZB
****
**** Now plot this point testing for obscuring as before.
****
     IF(Z.LT.ZP(IATOM))GO TO 5
     GO TO 2
****
**** After plotting add increment to theta.
****
  14 IP=IP+1
     IF(IP.LE.NPP)GO TO 13
****
**** End of circle
****
     IUP=1
  15 NN=NN+1
     IF(NN.LE.NOBSC)GO TO 9
****
**** Draw shade lines on surface of sphere. light source at yrot,zrot
**** given by (ang1,ang2)
****
  16 IF(ISHADE.NE.1)GO TO 20
     JIN=0
     NPP=NPP/2
     IF(ITRACE.GT.1)RADIUS=RADIUS-FLOAT(ITRACE)*TRSTEP
     YS=-RADIUS
     RADIAN=180.0/PI
     A=ANG1/RADIAN
     B=ANG2/RADIAN
     CA=COS(A)
     CB=COS(B)
     SB=SIN(B)
     NN=1
****
**** Once through this loop for each shading line to be drawn
**** inner loop to retrace shade lines
****
  17 DO 19 I=1,ITRACE
        RSQ=RADIUS*RADIUS-YS*YS
        IF(RSQ.LT.0.1)GO TO 117
        R1=SQRT(RSQ)
****
****    Set up end-points of line
****
        X=CB*CA*R1+SB*YS+XCENT
        Y=-SB*CA*R1+CB*YS+YCENT
        XX=-CB*R1+SB*YS+XCENT
        YY=SB*R1+CB*YS+YCENT
        IF(NN.GT.0)GO TO 18
        Z=X
        X=XX
        XX=Z
        Z=Y
        Y=YY
        YY=Z
  18    CALL BONDIN(IATOM,0,XP,YP,ZP,RP,NOBSC,0.,0.,1,PLSTEP,DPLOT,
    *      X,Y,XX,YY,0,IOBSC,NSZ1)
****
**** End of loop for shading
****
     NN=-NN
 117 YS=YS+TRSTEP
  19 CONTINUE
     YS=YS-TRSTEP
     YS=YS+SHADEN
     IF(YS.LT.RADIUS)GO TO 17
****
**** Mark atom centre with a cross
****
  20 IF(ISHADE.NE.2)GO TO 21
     I=1
     CALL ZDRAW(I,XCENT,YCENT)
     CALL ZMARK
  21 RETURN
****
     END
****
     SUBROUTINE BONDIN(IATOM,JATOM,XP,YP,ZP,RP,NOBSC,TAPER,RBO,NLI,
    *           PLINC,DPL,XSTART,YSTART,XEND,YEND,IEND,IOBSC,NSZ1)
****
     DIMENSION V(50,2),W(50,2)
     DIMENSION XP(1),YP(1),ZP(1),RP(1)
     DIMENSION IOBSC(NSZ1)
****
     COMMON /SCRAT1/ U1(3),U2(3),U3(3),ZAX(3),DC(3),P(3),Q(3)
****
     I=IATOM
     N=JATOM
     NN=1
     NEND=0
     IDOWN=0
     NBLINE=IABS(NLI)
****
**** Jump to 8 for atom shading
****
     IF(N.EQ.0)GO TO 8
     XI=XP(I)
     YI=YP(I)
     ZI=ZP(I)
     XN=XP(N)
     YN=YP(N)
     ZN=ZP(N)
     RI=RP(I)
     RN=RP(N)
     DX=XN-XI
     DY=YN-YI
     DZ=ZN-ZI
     DXYZ=SQRT(DX*DX+DY*DY+DZ*DZ)
     RISQ=RI*RI
     RNSQ=RN*RN
     IF(NLI.LE.1.OR.RBO.LT.0.001)GO TO 9
****
**** Solid bonds are to be drawn
**** Get bond centre line direction-cosines
****
     U3(1)=DX/DXYZ
     U3(2)=DY/DXYZ
     U3(3)=DZ/DXYZ
     IF(ABS(U3(3)).GT.0.9999)GO TO 31
     ZAX(1)=0.
     ZAX(2)=0.
     ZAX(3)=1.0
****
**** Set up coord system for the semi-circle cross-section of bond.
****
     CALL VPROD(ZAX,U3,U1)
     CALL VPROD(U3,U1,U2)
****
**** Get bond radius at atoms i and n.
****
     IF(ABS(TAPER).LE.1.0E-06)GO TO 1
     T=ABS(TAPER*U3(3))
     RB1=RBO*(1.+T)
     RB2=RBO*(1.-T)
     GO TO 2
****
   1 RB1=RBO*DPL/(DPL-ZI)
     RB2=RBO*DPL/(DPL-ZN)
   2 IF(RB1.GT.RI)RB1=RI-0.001
     IF(RB2.GT.RN)RB2=RN-0.001
     RB1=AMAX1(RB1,0.0)
     RB2=AMAX1(RB2,0.0)
   3 NLIN=0
     T=0.
     DELT=3.14159/FLOAT(NBLINE-1)
****
**** Set up points on semicircle at centres of atoms.
****
   4 COST=COS(T)
     SINT=SIN(T)
     CX=RB1*COST
     CY=RB1*SINT
     P(1)=U1(1)*CX+U2(1)*CY
     P(2)=U1(2)*CX+U2(2)*CY
     P(3)=U1(3)*CX+U2(3)*CY
     P(1)=P(1)+XI
     P(2)=P(2)+YI
     P(3)=P(3)+ZI
****
**** And again for point q.
****
     CX=RB2*COST
     CY=RB2*SINT
     Q(1)=U1(1)*CX+U2(1)*CY
     Q(2)=U1(2)*CX+U2(2)*CY
     Q(3)=U1(3)*CX+U2(3)*CY
     Q(1)=Q(1)+XN
     Q(2)=Q(2)+YN
     Q(3)=Q(3)+ZN
****
**** Get direction cosines for this line pq.
****
     D1=Q(1)-P(1)
     D2=Q(2)-P(2)
     D3=Q(3)-P(3)
     D=SQRT(D1*D1+D2*D2+D3*D3)
     DC(1)=D1/D
     DC(2)=D2/D
     DC(3)=D3/D
     DELX=DC(1)*PLINC
     DELY=DC(2)*PLINC
     DELZ=DC(3)*PLINC
****
**** Now find point where line emerges from sphere of atom i.
****
     E=SQRT(RISQ-RB1*RB1)
     XSTART=P(1)+E*DC(1)
     YSTART=P(2)+E*DC(2)
     ZSTART=P(3)+E*DC(3)
     IF(NEND.EQ.0)GO TO 5
     V(NLIN+1,1)=XSTART
     V(NLIN+1,2)=YSTART
****
**** Test if this point is obscured by circle i
****
   5 IF(ZSTART.GT.ZI)GO TO 7
****
**** Obscured therefore move along line to circumference of circle i
**** or omit point v
****
     IF(NEND.EQ.0)GO TO 6
     V(NLIN+1,1)=-1.
     GO TO 7
****
   6 XSTART=XSTART+DELX
     YSTART=YSTART+DELY
     ZSTART=ZSTART+DELZ
     DX=XSTART-XI
     DY=YSTART-YI
     IF(DX*DX+DY*DY.LT.RISQ)GO TO 6
****
**** Now get the end point of the line. ( intersection with sphere n.)
****
   7 F=SQRT(RNSQ-RB2*RB2)
     XEND=Q(1)-F*DC(1)
     YEND=Q(2)-F*DC(2)
     IF(NEND.EQ.0)GO TO 10
     W(NLIN+1,1)=XEND
     W(NLIN+1,2)=YEND
     NLIN=NLIN+1
     IF(NLIN.GT.NBLINE)GO TO 23
     T=T+DELT
     GO TO 4
****
   8 DX=XEND-XSTART
     DY=YEND-YSTART
     DL=SQRT(DX*DX+DY*DY)
     DELX=DX*PLINC/DL
     DELY=DY*PLINC/DL
     DINC=PLINC
     GO TO 12
****
**** Single line bond to be drawn
****
   9 NLIN=0
****
**** Get direction cosines of bond in xy plane  bl,bm
****
     DXY=SQRT(DX*DX+DY*DY)
     BL=DX/DXY
     BM=DY/DXY
****
**** Get the starting point which is on the circumference of circle i
****
     XSTART=XI+BL*RI
     YSTART=YI+BM*RI
****
**** Now get the end point for the bond
****
     XEND=XN-RN*DX/DXYZ
     YEND=YN-RN*DY/DXYZ
     DELX=BL*PLINC
     DELY=BM*PLINC
****
**** Start plotting the line xstart-xend
****
  10 NLIN=NLIN+1
****
**** We jump if the bond is completely obscured by the atom i
****
     X=XEND-XI
     Y=YEND-YI
     IF(X*X+Y*Y.LE.RISQ)GO TO 21
     IF(NN.GT.0)GO TO 11
     X=XSTART
     XSTART=XEND
     XEND=X
     X=YSTART
     YSTART=YEND
     YEND=X
     DELX=-DELX
     DELY=-DELY
  11 DXL=XEND-XSTART
     DYL=YEND-YSTART
     DL=SQRT(DXL*DXL+DYL*DYL)
     DINC=SQRT(DELX*DELX+DELY*DELY)
  12 X=XSTART
     Y=YSTART
     IF(NOBSC.EQ.0)GO TO 20
****
**** Start of testing for obscuring by atoms k
****
  13 IF(NOBSC.EQ.0)GO TO 15
     DO 14 L=1,NOBSC
        J=IOBSC(L)
        K=IABS(J)
        IF(NEND.EQ.2)J=K
        RK=RP(K)
        RK=RK*RK
        DXK=X-XP(K)
        DXK=DXK*DXK
        DYK=Y-YP(K)
        DYK=DYK*DYK
        RK=RK-DXK-DYK
        IF(RK.LT.0.)GO TO 14
        IF(J.GT.0)GO TO 16
        RI=RP(I)
        RI=RI*RI
        DXI=X-XP(I)
        DXI=DXI*DXI
        DYI=Y-YP(I)
        DYI=DYI*DYI
        RI=RI-DXI-DYI
        IF(RI.LT.0.)GO TO 16
        RI=SQRT(RI)+ZP(I)
        RK=SQRT(RK)+ZP(K)
        IF(RK.GT.RI)GO TO 16
  14 CONTINUE
****
**** No obscuring .  Go ahead with this step
**** IDRAW signals whether to draw the line at the current point
**** (0/1 for no/yes)
**** IDOWN records the apparent status of the pen = 0/1 for up/down
****
  15 IF(NEND.GE.1)GO TO 27
     IDRAW=1
     GO TO 17
****
**** Lift pen when obscuring found
****
  16 IF(NEND.GE.1)GO TO 26
     IDRAW=0
  17 IF(DL.LE.0.0)IDRAW=0
     IF(IDRAW.EQ.0)GO TO 18
     IF(IDOWN.EQ.1)GO TO 19
****
**** Note the starting point of a line segment at this point (xa,ya).
****
     XA=X
     YA=Y
     IDOWN=1
     GO TO 19
****
**** Obscuring occurs at this point. Draw line segment (xa,ya) to (x,y)
**** then lift the pen.
****
  18 IF(IDOWN.EQ.0)GO TO 19
     L=1
     CALL ZDRAW(L,XA,YA)
     L=2
     CALL ZDRAW(L,X,Y)
     IDOWN=0
****
**** Test for end of bond line.
****
  19 IF(DL.LE.0.0)GO TO 21
     X=X+DELX
     Y=Y+DELY
     DL=DL-DINC
     GO TO 13
****
**** Simple case of there being no obscuring atoms. draw line i to n
****
  20 L=1
     CALL ZDRAW(L,XSTART,YSTART)
     L=2
     CALL ZDRAW(L,XEND,YEND)
  21 CONTINUE
     IF(NLI.LE.1.OR.RBO.LE.0.001)GO TO 31
     IF(NLIN.GE.NBLINE)GO TO 22
****
**** Draw next line in reverse direction
****
     T=T+DELT
     NN=-NN
     GO TO 4
****
**** Draw ends of solid bond
****
  22 IF(IEND.EQ.0)GO TO 31
     NBLINE=INT(RB2*20.)
     IF(NBLINE.LT.2)GO TO 31
     NBLINE=MIN0(NBLINE,49)
     NEND=1
****
**** Set up points at bond ends
****
     GO TO 3
****
**** Plot near end if visible
****
  23 I=0
     IDOWN=0
  24 I=I+1
     IF(I.GT.NBLINE)GO TO (28,31),NEND
     X=V(I,1)
     Y=V(I,2)
     GO TO (25,30),NEND
****
  25 IF(X.LT.0.)GO TO 26
     GO TO 13
****
  26 IDOWN=0
     GO TO 24
****
  27 J=IDOWN+1
     CALL ZDRAW(J,X,Y)
     IDOWN=1
     GO TO 24
****
**** Plot far end
****
  28 DO 29 I=1,NBLINE
        V(I,1)=W(I,1)
        V(I,2)=W(I,2)
  29 CONTINUE
     NEND=2
     GO TO 23
****
  30 XEND=X-XI
     YEND=Y-YI
     IF(XEND*XEND+YEND*YEND.LE.RISQ)GO TO 26
     GO TO 13
****
  31 RETURN
****
     END
****
     SUBROUTINE  VPROD(A,B,C)
****
     DIMENSION A(3),B(3),C(3)
****
**** C will be the vector product of a x b  and will be normalised
**** to unit length
****
     C(1)=A(2)*B(3)-A(3)*B(2)
     C(2)=A(3)*B(1)-A(1)*B(3)
     C(3)=A(1)*B(2)-A(2)*B(1)
     D=SQRT(C(1)*C(1)+C(2)*C(2)+C(3)*C(3))
     IF(D.LT.0.0001)D=1.
     C(1)=C(1)/D
     C(2)=C(2)/D
     C(3)=C(3)/D
     RETURN
****
     END
****
     SUBROUTINE DSCAN(MODE,IUNIQ,INTER,IPRINT,NAME,X,XO,RADI,INCL,
    *           ILAB,ITYPE,IC,XP,YP,ZP,RP,MOL,IDONE,IFIX,INEXT,
    *           NSZ1,NSZ2,NSZ3)
****
     COMMON /AAA   / NAT,NATOS,NATO,NC,NC1,IERR,IPLOT
     COMMON /BBB   / IBS(30,3),R(3,3),NMOL,NSPEC,NATOT,ICELL,
    *                ISTER,IPERS,ISOL,TAPER,ITRACE,ICOPY,IPLOTR,CHSIZE,
    *                SIZEM,SCA,DPLOT,S,ITRACH,ITRACV,TRLAB,ISHADE,ANG1,
    *                ANG2,SHADEN,PLSTEP,TRSTEP,IEND,SHRINK,YLIM,TSIZE,
    *                NMOL1
     COMMON /CELL  / ACELL,BCELL,CCELL,ALF,BET,GAM,OR1,OR2,OR3,OR4,OR5,
    *                OR6,D100,D010,D001
     COMMON /SYM   / RS(24,3,4),NSYM,ICENT
     COMMON /FRN   / FN(40),NCHAR,KN,KL
     COMMON /SCRAT / AXIS(3),KEY(3),DLIM(3),XI(3),
    *                XJS(3),T(3),CMIN(3),CMAX(3),CENT(3),SEP(3),NSGA
****
     CHARACTER NAME,NAMX,MARK
****
     DIMENSION NAME(6,NSZ1),X(3,NSZ1),XO(3,NSZ1),RADI(NSZ1),
    *          INCL(NSZ1),ILAB(NSZ1),ITYPE(NSZ1),IC(NSZ2),
    *          XP(NSZ3),YP(NSZ3),ZP(NSZ3),RP(NSZ3),MOL(4,NSZ3),
    *          IDONE(NSZ1),IFIX(NSZ1),INEXT(NSZ1),NAMX(6)
****
     IF(MODE.EQ.999)GO TO 23
****
**** Find molecules having their centre wthin the range given
****
     CMIN(1)=FN(1)
     CMAX(1)=FN(2)
     CMIN(2)=FN(3)
     CMAX(2)=FN(4)
     CMIN(3)=FN(5)
     CMAX(3)=FN(6)
     NMOL=NMOL1
     DO 2 K=1,3
        C1=1.0E10
        C2=-C1
        DO 1 I=9,NATO
           C=X(K,I)
           C1=AMIN1(C1,C)
           C2=AMAX1(C2,C)
   1    CONTINUE
        SEP(K)=(C1+C2)/2.0
        CENT(K)=SEP(K)
   2 CONTINUE
     IF(MODE.EQ.0)GO TO 3
     CENT(1)=X(1,MODE)
     CENT(2)=X(2,MODE)
     CENT(3)=X(3,MODE)
   3 WRITE(6,4)CENT
     IF(NMOL.EQ.0)GO TO 7
     DO 6 I=1,NMOL
        XX=FLOAT(ISIGN(1,MOL(1,I)))
        N=IABS(MOL(1,I))
        DO 1155 K=1,3
           XI(K)=XX*RS(N,K,4)+FLOAT(MOL(K+1,I))
           DO 5 J=1,3
              XI(K)=XI(K)+RS(N,K,J)*SEP(J)*XX
   5       CONTINUE
1155    CONTINUE
        XP(I)=XI(1)
        YP(I)=XI(2)
        ZP(I)=XI(3)
   6 CONTINUE
   7 XX=CENT(1)
     YY=CENT(2)
     ZZ=CENT(3)
     DO 18 N=1,NSYM
        NB=N
        BB=1.
        DO 8 K=1,3
           XI(K)=RS(N,K,1)*XX+RS(N,K,2)*YY+RS(N,K,3)*ZZ+RS(N,K,4)
   8    CONTINUE
   9    T(1)=0.
        T(2)=0.
        T(3)=0.
        K=1
  10    IF(XI(K).LT.CMIN(K))GO TO 11
        XI(K)=XI(K)-1.0
        T(K)=T(K)-1.0
        GO TO 10
****
  11    XI(K)=XI(K)+1.0
        T(K)=T(K)+1.0
        IF(XI(K).GT.CMAX(K))GO TO 16
        K=K+1
        IF(K.LE.3)GO TO 10
****
****    Check for duplication of molecules in the list
****
        IF(NMOL.EQ.0)GO TO 14
        DO 112 L=1,3
           CENT(L)=BB*RS(N,L,4)+T(L)
           DO 12 J=1,3
              CENT(L)=RS(N,L,J)*SEP(J)*BB+CENT(L)
  12       CONTINUE
 112    CONTINUE
        DO 13 I=1,NMOL
           IF(ABS(CENT(1)-XP(I))+ABS(CENT(2)-YP(I))+ABS(CENT(3)-ZP(I))
    *         .LE.0.01)GO TO 15
  13    CONTINUE
        IF(NMOL.GE.NSZ1)GO TO 21
  14    NMOL=NMOL+1
        MOL(1,NMOL)=NB
        MOL(2,NMOL)=INT(T(1))
        MOL(3,NMOL)=INT(T(2))
        MOL(4,NMOL)=INT(T(3))
        XP(NMOL)=CENT(1)
        YP(NMOL)=CENT(2)
        ZP(NMOL)=CENT(3)
  15    K=K-1
        GO TO 11
****
  16    K=K-1
        IF(K.GT.0)GO TO 11
        IF(ICENT.EQ.0)GO TO 18
        IF(NB.LT.0)GO TO 18
        NB=-NB
        BB=-1.
        DO 17 K=1,3
           XI(K)=-RS(N,K,1)*XX-RS(N,K,2)*YY-RS(N,K,3)*ZZ-RS(N,K,4)
  17    CONTINUE
        GO TO 9
****
  18 CONTINUE
  19 WRITE(6,20)NMOL
     GO TO 95
****
  21 WRITE(6,22)
     GO TO 19
****
**** Automatic search for connections
****
  23 IF(NMOL.GT.0.AND.INTER.EQ.1)GO TO 24
     MOL(1,1)=1
     MOL(2,1)=0
     MOL(3,1)=0
     MOL(4,1)=0
     NMOL=1
     IF(IUNIQ.EQ.1)NMOL1=1
     NATOS=NATO
  24 NAT=NATOS
     NRES=1
     NSP=0
     NOM=0
     MOVE=0
     MARK='&'
     IF(INTER.EQ.1)GO TO 25
     MARK='*'
     NC1=12
  25 NC=NC1
     INTER=INTER+IUNIQ
     NC2=NC
****
**** Decide order of axes in descending axial length.
****
     AXIS(1)=ACELL
     AXIS(2)=BCELL
     AXIS(3)=CCELL
     IF(ABS(ACELL-BCELL).LE.1.0E-06.OR.ABS(ACELL-CCELL).LE.1.0E-06)
    *   AXIS(1)=ACELL+.0002
     IF(ABS(BCELL-CCELL).LE.1.0E-06)AXIS(2)=BCELL+.0001
     AXHI=AMAX1(AXIS(1),AXIS(2),AXIS(3))
     AXLO=AMIN1(AXIS(1),AXIS(2),AXIS(3))
     DO 28 K=1,3
        IF(ABS(AXIS(K)-AXHI).LE.1.0E-06)GO TO 26
        IF(ABS(AXIS(K)-AXLO).LE.1.0E-06)GO TO 27
        KEY(K)=2
        GO TO 28
****
  26    KEY(K)=1
        GO TO 28
****
  27    KEY(K)=3
  28 CONTINUE
     KX=KEY(1)
     KY=KEY(2)
     KZ=KEY(3)
     DO 29 I=9,NSZ1
        IDONE(I)=0
        IFIX(I)=0
        INEXT(I)=0
  29    CONTINUE
     NSG=0
     I=9
****
**** Start loop on atom i
****
  30 IFIX(I)=MAX0(IFIX(I),1)
     IF(INCL(I).EQ.0)GO TO 65
     XI(KX)=X(1,I)
     XI(KY)=X(2,I)
     XI(KZ)=X(3,I)
****
**** Start loop on atoms j
****
     J=9
  31 IF(INCL(J).EQ.0)GO TO 64
     DMAX=RP(I)+RP(J)
     DMAXSQ=DMAX*DMAX
****
**** Set up the d limits for each axis
****
     DLIM(KX)=DMAX/D100
     DLIM(KY)=DMAX/D010
     DLIM(KZ)=DMAX/D001
****
**** Start loop on symmetry operators
****
     DO 63 N=1,NSYM
        XCENT=1.
        NN=1
  32    NNN=N*NN
        IF(INTER.EQ.0.AND.NNN.NE.1)GO TO 64
        XX=X(1,J)
        YY=X(2,J)
        ZZ=X(3,J)
        XF=RS(N,1,1)*XX+RS(N,1,2)*YY+RS(N,1,3)*ZZ+RS(N,1,4)
        YF=RS(N,2,1)*XX+RS(N,2,2)*YY+RS(N,2,3)*ZZ+RS(N,2,4)
        ZF=RS(N,3,1)*XX+RS(N,3,2)*YY+RS(N,3,3)*ZZ+RS(N,3,4)
        XF=XF*XCENT
        YF=YF*XCENT
        ZF=ZF*XCENT
        XJS(KX)=XF
        XJS(KY)=YF
        XJS(KZ)=ZF
****
****    Begin translational search routine.
****
        T(1)=0.
        T(2)=0.
        T(3)=0.
        K=1
        IF(INTER.EQ.1)GO TO 34
****
****    No calculation of intermolecular distances.
****
        IF(I.EQ.J)GO TO 62
        DO 33 K=1,3
           SEP(K)=XI(K)-XJS(K)
           IF(ABS(SEP(K)).GT.DLIM(K))GO TO 62
  33    CONTINUE
        GO TO 38
****
****    Translate xjs on axis k to a point below lower limit.
****
  34    IF(XI(K)-XJS(K) .GT.DLIM(K))  GO TO 35
        XJS(K)=XJS(K)-1.0
        T(K)=T(K)-1.0
        GO TO 34
****
****    Advance +1.0 on axis k.
****
  35    XJS(K)=XJS(K)+1.0
        T(K)=T(K)+1.0
        SEP(K)=XJS(K)-XI(K)
        IF(SEP(K).LT.-DLIM(K))GO TO 35
****
****    Test if xjs-xi less than or equal to dlim(k)
****
        IF(SEP(K).GT.DLIM(K))  GO TO 36
        GO TO 37
****
****    Test gives atom out of range. reduce axis k by 1.
****
  36    K=K-1
        IF(K) 61,61,35
****
****    K=0 signals the end of the search
****    If xjs was within range on axis k then we advance k by 1
****
  37    K=K+1
        IF(K.LE.3)  GO TO 34
****
****    Atom in range for all 3 axes. now calculate exact distance.
****
        IT=INT(ABS(T(KX))+ABS(T(KY))+ABS(T(KZ)))
****
****    Eliminate distance of atom from itself.
****
        IF(NNN.EQ.1.AND.IT.EQ.0.AND.I.EQ.J)GO TO 39
        IF(IUNIQ.EQ.1)GO TO 38
        IF(INTER.EQ.0)GO TO 38
****
****    Eliminate intramol dists if intermol search only
****
        IF(NNN.EQ.1.AND.IT.EQ.0)GO TO 39
  38    DXO=OR1*SEP(KX)
        DYO=OR2*SEP(KX)+OR3*SEP(KY)
        DZO=OR4*SEP(KX)+OR5*SEP(KY)+OR6*SEP(KZ)
        DIJSQ=DXO*DXO+DYO*DYO+DZO*DZO
        IF(DIJSQ.LE.DMAXSQ)  GO TO 40
  39    K=K-1
        IF(INTER.EQ.0)GO TO 62
        GO TO 35
****
****    We have a distance less than or equal to dmax. store connection
****
  40    DIJ=SQRT(DIJSQ)
        XJST=XJS(KX)
        YJST=XJS(KY)
        ZJST=XJS(KZ)
        IF(DIJ.GT.0.05)  GO TO 48
        IF(J.GT.NAT)GO TO 39
        IFIX(J)=MAX0(IFIX(J),1)
        IDONE(J)=1
        IF(I.EQ.J)GO TO 47
****
****    Delete symmetry-equivalent atom
****
        IF(IFIX(J).EQ.2) MOVE=MOVE-1
        INEXT(J)=0
        L=12
 410    L=L+1
        IL=IC(L)/1000
        IF(IL-J) 41,42,46
  41    IL=MOD(IC(L),1000)
        IF(IL.NE.J)GO TO 45
  42    NC=NC-1
        IF(L.GT.NC)GO TO 44
        DO 43 NSGA=L,NC
           IC(NSGA)=IC(NSGA+1)
  43    CONTINUE
  44    IF(IUNIQ.NE.INTER.AND.L.LE.NC1) NC1=NC1-1
  45    CONTINUE
        IF(L.LT.NC)GO TO 410
  46    IFIX(J)=I
        NOM=NOM+1
        GO TO 62
****
****    Atom in special position
****
  47    INCL(I)=ISIGN(100,INCL(I))+INCL(I)
        IF(IUNIQ.EQ.1) NSP=NSP+1
        GO TO 39
****
****    Decide what to do with this connection.
****
  48    KAT=J
        NEW=1
        IF(INTER.EQ.0)GO TO 58
        IF(IUNIQ.EQ.0)GO TO 51
****
****    Unique mode only
****
        IF(IDONE(J).EQ.0)  INEXT(J)=1
        ITX=0
        IF(NNN.EQ.1.AND.IT.EQ.0) ITX=1
        IF(ITX*IFIX(J).GE.1)GO TO 57
        IF(IFIX(J).GE.1)GO TO 49
        IFIX(J)=MAX0(IFIX(J),1)
        IF(ITX.EQ.1)GO TO 57
****
****    Move atom j
****
        X(1,J)=XJST
        X(2,J)=YJST
        X(3,J)=ZJST
        XO(1,J)=OR1*X(1,J)
        XO(2,J)=OR2*X(1,J)+OR3*X(2,J)
        XO(3,J)=OR4*X(1,J)+OR5*X(2,J)+OR6*X(3,J)
        IFIX(J)=2
        MOVE=MOVE+1
        GO TO 57
****
****    Test for symmetry generated atom j'
****
  49    XX=X(1,I)
        YY=X(2,I)
        ZZ=X(3,I)
        XF=(RS(N,1,1)*XX+RS(N,1,2)*YY+RS(N,1,3)*ZZ+RS(N,1,4))*XCENT+
    *      T(K)
        YF=(RS(N,2,1)*XX+RS(N,2,2)*YY+RS(N,2,3)*ZZ+RS(N,2,4))*XCENT+
    *      T(K)
        ZF=(RS(N,3,1)*XX+RS(N,3,2)*YY+RS(N,3,3)*ZZ+RS(N,3,4))*XCENT+
    *      T(K)
        IF(ABS(XX-XF).GT.0.0001)GO TO 50
        IF(ABS(YY-YF).GT.0.0001)GO TO 50
        IF(ABS(ZZ-ZF).GT.0.0001)GO TO 50
        NEW=0
  50    IF(ABS(X(1,J)-XJST) .GT.0.0001)   GO TO 51
        IF(ABS(X(2,J)-YJST) .GT.0.0001)   GO TO 51
        IF(ABS(X(3,J)-ZJST) .GT.0.0001)   GO TO 51
        GO TO 57
****
****    Add atom to list. The extra atoms are used for drawing bonds
****    between molecules. The circles are not to be drawn however.
****    Test for duplication of atom coords in list.
****
  51    IF(NEW.EQ.0)GO TO 55
        NATC=NAT+NSG
        DO 52 L=9,NATC
           IF(ABS(X(1,L)-XJST).LT.0.0001.AND.ABS(X(2,J)-YJST).LT.0.0001
    *         .AND.ABS(X(3,L)-ZJST).LT.0.0001)GO TO 39
  52    CONTINUE
        NSG=NSG+1
        KAT=NATOS+NSG
        IF(KAT.GT.NSZ1)GO TO 96
        X(1,KAT)=XJST
        X(2,KAT)=YJST
        X(3,KAT)=ZJST
        XO(1,KAT)=OR1*X(1,KAT)
        XO(2,KAT)=OR2*X(1,KAT)+OR3*X(2,KAT)
        XO(3,KAT)=OR4*X(1,KAT)+OR5*X(2,KAT)+OR6*X(3,KAT)
        DO 53 L=1,6
           NAMX(L)=NAME(L,J)
           IF(NAME(L,J).NE.' ')GO TO 53
           IF(NAME(L-1,J).NE.' ')NAMX(L)=MARK
  53    CONTINUE
        DO 54 L=1,6
           NAME(L,KAT)=NAMX(L)
  54    CONTINUE
        INCL(KAT)=(1-J)*IUNIQ-INTER
        IF(IUNIQ.EQ.1) INCL(J)=ISIGN((IABS(INCL(J))/100)*100+KAT,
    *      INCL(J))
        ILAB(KAT)=ILAB(J)
        ITYPE(KAT)=ITYPE(J)
        RADI(KAT)=RADI(J)
        RP(KAT)=RP(J)
****
****    Add molecule to list
****
  55    ITX=INT(T(KX))
        ITY=INT(T(KY))
        ITZ=INT(T(KZ))
        DO 56 MM=1,NMOL
          IF(MOL(1,MM).EQ.NNN.AND.MOL(2,MM).EQ.ITX.AND.
    *        MOL(3,MM).EQ.ITY .AND.MOL(4,MM).EQ.ITZ)GO TO 58
  56    CONTINUE
        IF(NMOL.GE.NSZ1)GO TO 100
        NMOL=NMOL+1
        IF(IUNIQ.EQ.1)NMOL1=NMOL
        MOL(1,NMOL)=NNN
        MOL(2,NMOL)=ITX
        MOL(3,NMOL)=ITY
        MOL(4,NMOL)=ITZ
****
****    Add connection to list
****
  57    CONTINUE
  58    IF(I.GT.KAT)GO TO 39
        IF(NEW.EQ.0)GO TO 39
        L=1000*I+KAT
        IF(NC.LT.13)GO TO 60
        DO 59 LL=13,NC
           IF(L.EQ.IC(LL))GO TO 39
  59    CONTINUE
  60    IF(NC.GE.NSZ2)GO TO 98
        NC=NC+1
        IC(NC)=L
        GO TO 39
****
****    End of translational search
****
  61    CONTINUE
****
****    End loop on symmetry operators.
****
  62    IF(ICENT.EQ.0.OR.NN.LT.0)GO TO 63
        XCENT=-1.
        NN=-1
        GO TO 32
****
  63 CONTINUE
****
**** End of loop on atoms j
****
  64 J=J+1
     IF(J.LE.NAT)GO TO 31
****
**** Now decide what to do about the next atom i
****
  65 IF(IUNIQ.EQ.0)GO TO 71
     IDONE(I)=1
     INEXT(I)=0
     DO 67 IL=9,NAT
        IF(INEXT(IL).EQ.1)GO TO 70
  67 CONTINUE
****
**** No connected atom is left to go to therefore we begin a new
**** residue, unless all atoms have been done
****
     DO 68 IL=9,NAT
        IF(IDONE(IL).EQ.0)GO TO 69
  68 CONTINUE
     GO TO 72
****
**** Set the next atom i for calculation
****
  69 NRES=NRES+1
  70 I=IL
     GO TO 30
****
**** Advance i to i+1 if not unique mode
****
  71 I=I+1
     IF(I.GT.NAT)GO TO 72
     GO TO 30
****
**** End of loop on i
****
  72 NSGA=NSG
     NAT=NATOS+NSGA
     IF(IUNIQ.EQ.1)NATOS=NAT
     IF(IUNIQ.EQ.INTER)NC1=NC
****
**** Print out what has been found
****
     IF(NOM.EQ.0)GO TO 76
     IF(IPRINT.EQ.0)GO TO 74
     WRITE(6,73)
  74 DO 75 I=9,NATO
        IF(IFIX(I).LE.8)GO TO 75
        INCL(I)=0
        IF(IPRINT.EQ.0)GO TO 75
        J=IFIX(I)
        WRITE(6,90)(NAME(K,J),K=1,6),(NAME(K,I),K=1,6)
  75 CONTINUE
  76 IF(IPRINT.EQ.0)GO TO 93
     IF(MOVE.EQ.0)GO TO 80
     WRITE(6,77)
     DO 79 I=9,NATO
        IF(IFIX(I).NE.2)GO TO 79
        WRITE(6,78)(NAME(K,I),K=1,6),X(1,I),X(2,I),X(3,I)
  79 CONTINUE
  80 IF(NSP.EQ.0)GO TO 84
     WRITE(6,81)
     J=NATO
     IF(IUNIQ.NE.INTER)J=NATOS
     DO 83 I=9,J
        IF(IABS(INCL(I)).LT.100)GO TO 83
        WRITE(6,82)(NAME(K,I),K=1,6)
  83 CONTINUE
  84 IF(NSGA.EQ.0)GO TO 87
     WRITE(6,85)
     J=NATO+1
     IF(IUNIQ.EQ.0)J=NATOS+1
     DO 86 I=J,NAT
        WRITE(6,82)(NAME(L,I),L=1,6)
  86 CONTINUE
  87 WRITE(6,88)
     IF(NC.EQ.NC2)GO TO 91
     M=NC2+1
     DO 89 K=M,NC
        I=IC(K)/1000
        J=MOD(IC(K),1000)
        WRITE(6,90)(NAME(L,I),L=1,6),(NAME(L,J),L=1,6)
  89 CONTINUE
  91 IF(NRES.EQ.1)GO TO 93
     WRITE(6,92)NRES
  93 WRITE(6,94)
  95 RETURN
****
  96 WRITE(6,97)
     GO TO 102
****
  98 WRITE(6,99)
     GO TO 102
****
 100 WRITE(6,101)
****
**** Search interrupted
****
 102 WRITE(6,103)
     NMOL=NMOL1
     NC=NC1
     NAT=NATOS
     RETURN
****
   4 FORMAT('0Molecular centre is at',3F8.4)
  20 FORMAT('0There are',I4,' molecules within specified range')
  22 FORMAT('0*** Molecule list full before search complete',//)
  73 FORMAT('0The following pairs of atoms are symmetry equivalent.',
    *       ' The second atom has been deleted in each case')
  77 FORMAT('0The following atoms have been moved:')
  78 FORMAT('0',6A1,' to ',3F10.5)
  81 FORMAT('0The following atoms are in special positions:',//)
  82 FORMAT(' ',3X,6A1)
  85 FORMAT('0The following symmetry-related atoms have been',
    *       ' generated for connections between molecules:',/,
    *       '+',91('_'),//)
  88 FORMAT('0The following connections have been generated:',/,
    *       '+______________________________________________',//)
  90 FORMAT(' ',3X,6A1,'--',6A1)
  92 FORMAT('0There are ',I3,' separate unconnected fragments')
  94 FORMAT('0',8('===='))
  97 FORMAT('0*** Atom list full because of symmetry-generated atoms',
    *       //)
  99 FORMAT('0*** Connections list full because of symmetry-',
    *       'generated atoms',//)
 101 FORMAT('0*** Molecule list full *** HELP',//)
 103 FORMAT(' *** Search interrupted: ALL generated atoms and ',
    *       'bonds cancelled',//)
****
     END
****
     SUBROUTINE INTERP(ICOUNT,NAME,X,XO,RADI,INCL,ILAB,ITYPE,IC,XP,YP,
    *           ZP,RP,MOL,IDONE,IFIX,INEXT,NSZ1,NSZ2,NSZ3,IBEG)
****
**** Declarations
****
     COMMON /AAA   / NAT,NATOS,NATO,NC,NC1,IERR,IPLOT
     COMMON /BBB   / IBS(30,3),R(3,3),NMOL,NSPEC,NATOT,ICELL,ISTER,
    *                IPERS,ISOL,TAPER,ITRACE,ICOPY,IPLOTR,CHSIZE,SIZEM,
    *                SCA,DPLOT,S,ITRACH,ITRACV,TRLAB,ISHADE,ANG1,ANG2,
    *                SHADEN,PLSTEP,TRSTEP,IEND,SHRINK,YLIM,TSIZE,NMOL1
     COMMON /BBBC  / ID(74)
     COMMON /CELL  / ACELL,BCELL,CCELL,ALF,BET,GAM,OR1,OR2,OR3,OR4,
    *                OR5,OR6,D100,D010,D001
     COMMON /EEE   / IENC,ENC(6)
     COMMON /SYM   / RS(24,3,4),NSYM,ICENT
     COMMON /DEF   / RBDEF,LBDEF,RADEF,SZDEF,CHDEF,DPDEF,TDEF,RBDEFN,
    *                LBDEFN,ANGDF1,ANGDF2,SHADEF,TAPDEF,TLDEF,TRDEF,
    *                PLDEF
     COMMON /FRC   / COL(80),FL(6,40)
     COMMON /FRN   / FN(40),NCHAR,KN,KL
     COMMON /ALPHA / LET(27)
     COMMON /IO    / IN
****
     CHARACTER FL,COL,NAME,J1,J2,J3,ID,LET,N1,N2,QUOTE,COLBUF*3
****
     EXTERNAL ALPHABET
****
     DIMENSION PLINE(3),V1(3),V2(3),V3(3),R1(3),R2(3),A(3,3),B(3,3),
    *          NAME(6,NSZ1),X(3,NSZ1),XO(3,NSZ1),RADI(NSZ1),INCL(NSZ1),
    *          ILAB(NSZ1),ITYPE(NSZ1),IC(NSZ2),XP(NSZ3),YP(NSZ3),
    *          ZP(NSZ3),RP(NSZ3),MOL(4,NSZ3),IDONE(NSZ1),IFIX(NSZ1),
    *          INEXT(NSZ1),JCELL(8),ICCELL(12)
****
     DATA QUOTE /Z7D/,IMAX/80/,ITEL/37/,
    *     JCELL /0,100,110,10,1,101,111,11/,
    *     ICCELL /1002,2003,3004,4001,1005,5006,6007,7008,8005,4008,
    *             7003,2006/
****
**** Initialise
****
     RAD=57.2958
     IERR=0
     IF(ICOUNT.GT.1)GO TO 4
****
**** Set cell corner coordinates.
****
     DO 2 I=1,8
        ILAB(I)=0
        INCL(I)=-1
        ITYPE(I)=0
        RADI(I)=0.
        X(1,I)=FLOAT(JCELL(I)/100)
        X(2,I)=FLOAT(MOD(JCELL(I)/10,10))
        X(3,I)=FLOAT(MOD(JCELL(I),10))
        DO 1 K=1,6
           NAME(K,I)=' '
   1    CONTINUE
   2 CONTINUE
     NAME(1,1)='O'
     NAME(1,2)='A'
     NAME(1,4)='B'
     NAME(1,5)='C'
     ILAB(1)=1
     ILAB(2)=1
     ILAB(4)=1
     ILAB(5)=1
****
**** Set up cell connectivity here.
****
     DO 3 K=1,12
        IC(K)=ICCELL(K)
   3 CONTINUE
****
**** All data cards read here
****
   4 READ(IN,5,END=248)COL
     IF(COL(1).EQ.' '.OR.COL(1).EQ.'-')GO TO 14
     WRITE(6,6)COL
     WRITE(COLBUF,5)(COL(I),I=1,3)
     READ(COLBUF,5)J1,J2,J3
****
**** Interpret setting-up instructions
****
     IF(COLBUF.EQ.'NAN')GO TO 4
     IF(COLBUF.EQ.'BEG')GO TO 22
     IF(ICOUNT.EQ.1)GO TO 23
   7 IF(COLBUF.EQ.'CEL')GO TO 27
     IF(COLBUF.EQ.'SYM')GO TO 28
     IF(COLBUF.EQ.'ANG')GO TO 34
     IF(COLBUF.EQ.'FRA')GO TO 35
     IF(COLBUF.EQ.'ATO')GO TO 38
     IF(COLBUF.EQ.'FVA')GO TO 36
     IF(COLBUF.EQ.'JOI')GO TO 48
     IF(COLBUF.EQ.'TIT')GO TO 66
     IF(COLBUF.EQ.'END')GO TO 247
****
**** Interpretation of plotting instructions
****
     CALL FREDA(1,IMAX)
     IF(COLBUF.EQ.'VIE')GO TO 72
     IF(COLBUF.EQ.'ALI')GO TO 118
     IF(COLBUF.EQ.'SOL')GO TO 124
     IF(COLBUF.EQ.'STI')GO TO 126
     IF(COLBUF.EQ.'LAB')GO TO 131
     IF(COLBUF.EQ.'UNL')GO TO 146
     IF(COLBUF.EQ.'PUT')GO TO 147
     IF(COLBUF.EQ.'RAD')GO TO 152
     IF(COLBUF.EQ.'PAC')GO TO 173
     IF(COLBUF.EQ.'MOL')GO TO 175
     IF(COLBUF.EQ.'INC')GO TO 182
     IF(COLBUF.EQ.'OMI')GO TO 181
     IF(COLBUF.EQ.'UNI')GO TO 201
     IF(COLBUF.EQ.'RET')GO TO 129
     IF(COLBUF.EQ.'STE')GO TO 202
     IF(COLBUF.EQ.'MON')GO TO 202
     IF(COLBUF.EQ.'SIZ')GO TO 203
     IF(COLBUF.EQ.'PRI')GO TO 206
     IF(COLBUF.EQ.'PLO')GO TO 234
     IF(COLBUF.EQ.'RES')GO TO 68
     IF(COLBUF.EQ.'SEG')GO TO 205
****
**** Perhaps unformatted atom card
**** Check syntax of first three cols for atom name . This must be a
**** one of two letter element symbol followed by a number, space or (.
****
     M=0
   8 K=0
     IF(J1.LT.'A'.OR.J1.GT.'Z')GO TO 10
     IF(J2.GE.'A'.AND.J2.LE.'Z')GO TO 9
     J3=J2
     J2=' '
   9 IF(J3.GE.'0'.AND.J3.LE.'9')GO TO 11
     IF(J3.EQ.' ')GO TO 11
     IF(J3.EQ.'(')GO TO 11
     IF(J3.EQ.QUOTE)GO TO 11
  10 IF(M.EQ.1)GO TO 12
     K=1
  11 IF(M.EQ.1)GO TO 40
     IF(KN.EQ.3)GO TO 39
     IF(KN.GE.4)GO TO 16
****
**** Unrecognised - ignore this card
****
  12 WRITE(6,13)
     GO TO 4
****
  14 WRITE(6,15)COL
     GO TO 4
****
**** This is considered to be a card from SHEL-X program
**** Skip the first numeric field which is the formfactor number.
****
  16 FN(1)=FN(2)
     FN(2)=FN(3)
     FN(3)=FN(4)
****
**** Interpret free variables and fixed coords
****
     IF(MA.NE.0)GO TO 39
     DO 19 K=1,3
        YY=FN(K)
        IF(YY.GT.-5.)GO TO 17
        YY=ABS(YY)
        Y=AINT((YY+5.)*0.1)
        I=INT(Y)
        IF(I.GT.NFVAR)GO TO 236
        YY=Y*10.-YY
        FN(K)=YY*(RP(I)-1.)
        GO TO 19
****
  17    IF(YY.LT.5.)GO TO 19
        IF(YY.GT.15.)GO TO 18
        FN(K)=YY-10.
        GO TO 19
****
  18    Y=AINT((YY+5.)*0.1)
        I=INT(Y)
        IF(I.GT.NFVAR)GO TO 236
        YY=YY-Y*10.
        FN(K)=YY*RP(I)
  19 CONTINUE
     GO TO 39
****
**** Begin card
****
  22 CALL FREDA(6,IMAX)
     M=1
     N=1
     IF(KL.EQ.0)GO TO 23
     IFOUT=0
     IF(FL(1,1).EQ.'S'.AND.FL(2,1).EQ.'P'.AND.FL(3,1).EQ.'E')
    *   CALL ZSPEC(YLIM,IFOUT)
     IF(IFOUT.NE.0)GO TO 236
  23 DO 24 I=1,74
        ID(I)=' '
  24 CONTINUE
     ICOUNT=ICOUNT+1
     NAT=8
     NC=12
     NC1=12
     NMOL=0
     NMOL1=0
     MA=0
     NFVAR=0
     IERR=0
     ICENT=0
     NSYM=1
     DO 26 I=1,3
        DO 25 J=1,4
           RS(1,I,J)=0.
  25    CONTINUE
        RS(1,I,I)=1.
  26 CONTINUE
     GO TO 68
****
**** Cell constants
****
  27 CALL FREDA(5,IMAX)
     K=0
     IF(KN.LT.6)GO TO 236
     IF(KN.EQ.7)K=1
     ACELL=FN(K+1)
     BCELL=FN(K+2)
     CCELL=FN(K+3)
     ALF=FN(K+4)
     BET=FN(K+5)
     GAM=FN(K+6)
     IF(ABS(ALF).LT.1.0.OR.ABS(BET).LT.1.0.OR.ABS(GAM).LT.1.0)GO TO 300
     GO TO 310
****
 300 ALF=ARCOS(ALF)*RAD
     BET=ARCOS(BET)*RAD
     GAM=ARCOS(GAM)*RAD
****
**** Orthogonalistion matrix or1-6
****
 310 SA=SIN(ALF/RAD)
     SB=SIN(BET/RAD)
     SG=SIN(GAM/RAD)
     CA=COS(ALF/RAD)
     CB=COS(BET/RAD)
     CG=COS(GAM/RAD)
     CGSTAR=(CA*CB-CG)/(SA*SB)
     SGSTAR=SQRT(1.0-CGSTAR**2)
     OR1=ACELL*SB*SGSTAR
     OR2=-ACELL*SB*CGSTAR
     OR3=BCELL*SA
     OR4=ACELL*CB
     OR5=BCELL*CA
     OR6=CCELL
****
**** Set up limits for testing if atom in range for distance calculatio
****
     VOL=ACELL*BCELL*CCELL*SQRT(1.0-CA*CA-CB*CB-CG*CG+2.0*CA*CB*CG)
     D100=VOL/(BCELL*CCELL*SA)
     D010=VOL/(ACELL*CCELL*SB)
     D001=VOL/(ACELL*BCELL*SG)
     GO TO 4
****
**** Symmetry card
****
  28 CALL FREDA(1,IMAX)
     IF(KL.EQ.2.AND.FL(1,2).EQ.'C')GO TO 33
     IF(KL.GT.1)GO TO 32
     IF(KN.NE.12)GO TO 32
****
**** This is a numerically coded symmetry operator.
****
     K=0
     IF(NSYM.GE.24)GO TO 30
     NSYM=NSYM+1
     DO 1129 I=1,3
        DO 29 J=1,4
           K=K+1
           RS(NSYM,I,J)=FN(K)
  29    CONTINUE
1129 CONTINUE
     GO TO 4
****
  30 WRITE(6,31)
     GO TO 4
****
**** This is an alphanumeric symmetry card, like internat. tabs.
****
  32 CALL SYMFRE(COL,RS,NSYM,IERR)
     GO TO 4
****
  33 ICENT=1
     GO TO 4
****
**** Angstrom card
****
  34 MA=1
     GO TO 4
****
**** Fractional card
****
  35 MA=0
     GO TO 4
****
**** Fvar list
****
  36 CALL FREDA(5,IMAX)
     IF(KN.EQ.0)GO TO 236
     DO 37 I=1,KN
        RP(NFVAR+I)=FN(I)
  37 CONTINUE
     NFVAR=NFVAR+KN
     GO TO 4
****
**** Atom as from data file
****
  38 CALL FREDA(7,ITEL)
     IF(KN.NE.3)GO TO 236
     M=1
     J1=FL(1,1)
     J2=FL(2,1)
     J3=FL(3,1)
     WRITE(COLBUF,5)J1,J2,J3
     GO TO 8
****
  39 IF(KL.LE.2)GO TO 390
     IF(FL(1,KL-1).EQ.'T')GO TO 45
 390 IF(K.EQ.1)GO TO 12
  40 IF(NAT.GE.NSZ1)GO TO 46
     NAT=NAT+1
     NATO=NAT
     NATOS=NAT
     X(1,NAT)=FN(1)
     X(2,NAT)=FN(2)
     X(3,NAT)=FN(3)
     IF(MA.EQ.1)GO TO 41
     IF(KL.EQ.1)GO TO 401
     IF(M.EQ.0.AND.FL(1,2).NE.'A')GO TO 42
     GO TO 402
****
 401 IF(M.EQ.0)GO TO 42
 402 IF(M.EQ.1.AND.COL(45).NE.'1')GO TO 42
  41 X(1,NAT)=X(1,NAT)/ACELL
     X(2,NAT)=X(2,NAT)/BCELL
     X(3,NAT)=X(3,NAT)/CCELL
  42 DO 43 K=1,6
        NAME(K,NAT)=FL(K,1)
  43 CONTINUE
****
**** Get a characteristic number to identify atom type later on.
****
     I=NAT
     DO 44 J=1,27
        IF(J1.EQ.LET(J))IN1=J
        IF(J2.EQ.LET(J))IN2=J
  44 CONTINUE
     ITYPE(I)=-(IN1*1000+IN2)
****
**** Orthonormal coords. calculated
****
     XO(1,I)=OR1*X(1,I)
     XO(2,I)=OR2*X(1,I)+OR3*X(2,I)
     XO(3,I)=OR4*X(1,I)+OR5*X(2,I)+OR6*X(3,I)
     INCL(I)=1
     ILAB(I)=0
     RADI(I)=RADEF
     GO TO 4
****
  45 J1=FL(1,KL)
     J2=FL(2,KL)
     IF(J1.LT.'A'.OR.J1.GT.'Z')GO TO 236
     IF((J2.LT.'A'.OR.J2.GT.'Z').AND.J2.NE.' ')GO TO 236
     GO TO 40
****
  46 WRITE(6,47)
     GO TO 4
****
**** Join card..... sets up connection array ic.
****
  48 CALL FREDA(5,IMAX)
     IF(KL.EQ.0)GO TO 236
     IF(FL(1,1).EQ.'R'.AND.FL(2,1).EQ.'A'.AND.FL(3,1).EQ.'D')GO TO 49
     IF(FL(1,1).EQ.'N'.AND.FL(2,1).EQ.'O'.AND.FL(3,1).EQ.'N')GO TO 57
     IF(FL(1,1).EQ.'I'.AND.FL(5,1).EQ.'A')GO TO 58
     IF(FL(1,2).EQ.'T'.AND.FL(2,2).EQ.'O')GO TO 62
     CALL ATOMID(1,IAT,NAME,NSZ1)
     IF(IAT)236,236,59
****
**** Radii given for distance scan
****
  49 IUNIQ=0
     IPRINT=1
     INTER=0
     N=0
     DO 50 I=1,NAT
        RP(I)=-10.
  50 CONTINUE
     DO 56 K=2,KL
        J1=FL(1,K)
        J2=FL(2,K)
        J3=FL(3,K)
        WRITE(COLBUF,5)J1,J2,J3
        IF(COLBUF.EQ.'UNI')GO TO 53
        IF(COLBUF.EQ.'NOP')GO TO 54
        IF(COLBUF.EQ.'INT')GO TO 55
        IF(COLBUF.EQ.'NON')GO TO 57
****
****    Test for atom type
****
        CALL ATOMID(K,IAT,NAME,NSZ1)
        IF(IAT)51,236,236
****
****    Type of atom list.  this is used to set atom radii for scan.
****
  51    M=IAT
        N=N+1
        DO 52 I=1,NAT
           IF(ITYPE(I).EQ.M)RP(I)=FN(N)
  52    CONTINUE
        GO TO 56
****
  53    IUNIQ=1
        GO TO 56
****
  54    IPRINT=0
        GO TO 56
****
  55    INTER=1
  56 CONTINUE
     CALL DSCAN(999,IUNIQ,INTER,IPRINT,NAME,X,XO,RADI,INCL,ILAB,ITYPE,
    *   IC,XP,YP,ZP,RP,MOL,IDONE,IFIX,INEXT,NSZ1,NSZ2,NSZ3)
     GO TO 4
****
  57 NC=12
     NC1=12
     GO TO 4
****
  58 NC=NC1
     GO TO 4
****
**** Specific atom connections
****
  59 DO 1161 K=2,KL
        IF(FL(1,K).EQ.'*')GO TO 60
        CALL ATOMID(K,JAT,NAME,NSZ1)
        IF(JAT.LE.0)GO TO 236
        IF(IAT.EQ.0)GO TO 61
        IF(NC.GE.NSZ2)GO TO 64
        NC=NC+1
        IC(NC)=1000*IAT+JAT
        GO TO 61
****
  60    JAT=0
  61    IAT=JAT
1161 CONTINUE
     NC1=NC
     GO TO 4
****
**** To list. join atom 1 to each of the following atoms on the card.
****
  62 CALL ATOMID(1,IAT,NAME,NSZ1)
     IF(IAT.LE.0)GO TO 236
     DO 63 K=3,KL
        CALL ATOMID(K,JAT,NAME,NSZ1)
        IF(JAT.LE.0)GO TO 236
        IF(NC.GE.NSZ2)GO TO 64
        NC=NC+1
        IC(NC)=1000*IAT+JAT
  63 CONTINUE
     NC1=NC
     GO TO 4
****
  64 WRITE(6,65)
     GO TO 4
****
**** Title for plot
****
  66 DO 67 I=1,74
     ID(I)=COL(I+6)
  67 CONTINUE
     IF(J1.EQ.'T')GO TO 4
****
**** Clear flags for plotting and set up defaults
****
  68 NMOL=NMOL1
     IERR=0
     ISOL=0
     ISTER=0
     IPERS=0
     IAL=0
     NSPEC=0
     ICELL=0
     SCA=0.
     ITRACE=1
     ITRACH=1
     ITRACV=1
     TRLAB=TLDEF
     TRSTEP=TRDEF
     PLSTEP=PLDEF
     ICOPY=1
     IENC=0
     IPLOTR=1
     ISHADE=0
     ANG1=ANGDF1
     ANG2=ANGDF2
     TAPER=TAPDEF
     RBDEF=RBDEFN
     LBDEF=LBDEFN
     IEND=0
     SHRINK=0.
     TSIZE=TDEF
     DO 70 I=1,3
        DO 69 J=1,3
           R(I,J)=0.
  69    CONTINUE
        R(I,I)=1.
  70 CONTINUE
     SHADEN=SHADEF
     SIZEM=SZDEF
     CHSIZE=CHDEF
     DPLOT=DPDEF
     IF(J1.EQ.'B')GO TO 4
     IF(J1.NE.'R')GO TO 7
     DO 71 I=9,NAT
        RADI(I)=RADEF
        ILAB(I)=0
        INCL(I)=IABS(INCL(I))
        IF(I.GT.NATO)INCL(I)=-INCL(I)
  71 CONTINUE
     GO TO 4
****
**** View definition
****
  72 N1=FL(1,2)
     N2=FL(2,2)
     L=2
     N=0
     IF(N1.EQ.'C'.AND.N2.EQ.'U')GO TO 93
     IF(N1.EQ.'M'.AND.N2.EQ.'A')GO TO 127
****
**** Keywords defining a rotation matrix to be calculated.
****
     DO 1173 I=1,3
        PLINE(I)=0.5
        DO 73 J=1,3
           R(I,J)=0.0
  73    CONTINUE
1173 CONTINUE
     IF(N1.EQ.'X')GO TO 74
     IF(N1.EQ.'Y')GO TO 75
     IF(N1.EQ.'Z')GO TO 76
     IF(N1.EQ.'A'.AND.N2.EQ.'F')GO TO 77
     IF(N1.EQ.'B'.AND.N2.EQ.'F')GO TO 78
     IF(N1.EQ.'C'.AND.N2.EQ.'F')GO TO 79
     IF(N1.EQ.'D')GO TO 82
     IF(N1.EQ.'L')GO TO 80
     IF(N1.EQ.'P')GO TO 86
     IF(N1.EQ.'B')GO TO 87
     GO TO 235
****
  74 R(1,2)=1.
     R(2,3)=1.
     R(3,1)=1.
     GO TO 93
****
  75 R(1,3)=1.
     R(2,1)=1.
     R(3,2)=1.
     GO TO 93
****
  76 R(1,1)=1.
     R(2,2)=1.
     R(3,3)=1.
     GO TO 93
****
  77 ILINE=1
     PLINE(1)=1.0
     GO TO 84
****
  78 ILINE=1
     PLINE(2)=1.0
     GO TO 84
****
  79 ILINE=1
     PLINE(3)=1.0
     GO TO 84
****
  80 ILINE=1
     IF(KL.LT.4)GO TO 236
     CALL ATOMID(3,IAT,NAME,NSZ1)
     CALL ATOMID(4,JAT,NAME,NSZ1)
     IF(IAT.LE.0.OR.JAT.LE.0)GO TO 236
     DO 81 K=1,3
        PLINE(K)=X(K,IAT)-X(K,JAT)
  81 CONTINUE
     L=L+2
     GO TO 84
****
  82 DO 83 K=1,3
        PLINE(K)=FN(K)
  83 CONTINUE
     ILINE=1
     L=2
     N=3
  84 XX=PLINE(1)
     YY=PLINE(2)
     ZZ=PLINE(3)
     V3(1)=OR1*XX
     V3(2)=OR2*XX+OR3*YY
     V3(3)=OR4*XX+OR5*YY+OR6*ZZ
****
**** Calc r matrix for line view
****
     V3MOD=SQRT(V3(1)*V3(1)+V3(2)*V3(2)+V3(3)*V3(3))
     DO 85 K=1,3
        V3(K)=V3(K)/V3MOD
  85 CONTINUE
     R2(1)=0.0
     R2(2)=0.0
     R2(3)=0.0
     IF(ABS(V3(2)).GT.0.9999)R2(1)=1.
     IF(ABS(R2(1)).LE.1.0E-06)R2(2)=1.0
     CALL VPROD(R2,V3,V1)
     CALL VPROD(V3,V1,V2)
     GO TO 92
****
  86 ILINE=2
     GO TO 88
****
  87 ILINE=3
  88 IF(KL.LT.5)GO TO 236
     IJ1=ICHAR(J1)
     IJ2=ICHAR(J2)
     IJ3=ICHAR(J3)
     CALL ATOMID(3,IJ1,NAME,NSZ1)
     CALL ATOMID(4,IJ2,NAME,NSZ1)
     CALL ATOMID(5,IJ3,NAME,NSZ1)
     IF(IJ1.LE.0.OR.IJ2.LE.0.OR.IJ3.LE.0)GO TO 236
     L=L+3
****
**** Calc r matrix for perp and bisect views
****
     DO 89 K=1,3
        V3(K)=0.5*(XO(K,IJ1)+XO(K,IJ3))-XO(K,IJ2)
        R1(K)=XO(K,IJ1)-XO(K,IJ2)
        R2(K)=XO(K,IJ3)-XO(K,IJ2)
  89 CONTINUE
     V3MOD=SQRT(V3(1)**2+V3(2)**2+V3(3)**2)
     R1MOD=SQRT(R1(1)**2+R1(2)**2+R1(3)**2)
     R2MOD=SQRT(R2(1)**2+R2(2)**2+R2(3)**2)
     DO 90 K=1,3
        V3(K)=V3(K)/V3MOD
        R1(K)=R1(K)/R1MOD
        R2(K)=R2(K)/R2MOD
  90 CONTINUE
****
**** Now get v2=v3xr2  and then v1=v2xv3
****
     CALL VPROD(V3,R2,V2)
     CALL VPROD(V2,V3,V1)
     IF(ILINE.EQ.3)GO TO 92
****
**** For perp  just swop axes
****
     DO 91 K=1,3
        TEMP=V3(K)
        V3(K)=V2(K)
        V2(K)=V1(K)
        V1(K)=TEMP
  91 CONTINUE
     GO TO 92
****
**** Set r matrix
****
  92 R(1,1)=V1(1)
     R(1,2)=V1(2)
     R(1,3)=V1(3)
     R(2,1)=V2(1)
     R(2,2)=V2(2)
     R(2,3)=V2(3)
     R(3,1)=V3(1)
     R(3,2)=V3(2)
     R(3,3)=V3(3)
****
**** Kewords giving rotations to be applied to the current r matrix
****
  93 L=L+1
     N=N+1
     IF(L.GT.KL)GO TO 115
     IF(N.GT.KN)GO TO 236
     DO 94 I=1,3
        DO 94 J=1,3
           A(I,J)=0.0
  94    CONTINUE
     ANG=FN(N)/RAD
     CA=COS(ANG)
     SA=SIN(ANG)
     N1=FL(1,L)
     IF(N1.EQ.'B')GO TO 100
     IF(N1.EQ.'L')GO TO 108
     IF(N1.EQ.'O')GO TO 110
     IF(N1.EQ.'P')GO TO 112
     IF(N1.EQ.'X')GO TO 96
     IF(N1.EQ.'Y')GO TO 95
     IF(N1.NE.'Z')GO TO 236
****
**** Z rotn
****
     A(1,1)=CA
     A(1,2)=SA
     A(2,1)=-SA
     A(2,2)=CA
     A(3,3)=1.0
     GO TO 97
****
**** Y rotn
****
  95 A(1,1)=CA
     A(1,3)=-SA
     A(2,2)=1.0
     A(3,1)=SA
     A(3,3)=CA
     GO TO 97
****
**** X rotn
****
  96 A(1,1)=1.0
     A(2,2)=CA
     A(2,3)=SA
     A(3,2)=-SA
     A(3,3)=CA
  97 DO 1198 I=1,3
        DO 98 J=1,3
           B(I,J)=A(I,1)*R(1,J)+A(I,2)*R(2,J)+A(I,3)*R(3,J)
  98    CONTINUE
1198 CONTINUE
     DO 1199 I=1,3
        DO 99 J=1,3
           R(I,J)=B(I,J)
  99    CONTINUE
1199 CONTINUE
     GO TO 93
****
**** Bond rotn
****
 100 IF((L+2).GT.KL)GO TO 236
     L=L+1
     CALL ATOMID(L,I,NAME,NSZ1)
     IF(I.LE.0)GO TO 236
     L=L+1
     CALL ATOMID(L,J,NAME,NSZ1)
     IF(J.LE.0)GO TO 236
     DO 101 K=1,3
        V1(K)=X(K,I)-X(K,J)
 101 CONTINUE
 102 V3(1)=OR1*V1(1)
     V3(2)=OR2*V1(1)+OR3*V1(2)
     V3(3)=OR4*V1(1)+OR5*V1(2)+OR6*V1(3)
 103 V3MOD=SQRT(V3(1)*V3(1)+V3(2)*V3(2)+V3(3)*V3(3))
     DO 104 K=1,3
        V3(K)=V3(K)/V3MOD
 104 CONTINUE
     DO 105 I=1,3
        V2(I)=R(I,1)*V3(1)+R(I,2)*V3(2)+R(I,3)*V3(3)
 105 CONTINUE
 106 CB=1.-CA
     DO 1107 I=1,3
        DO 107 J=1,3
           A(I,J)=CB*V2(I)*V2(J)
 107    CONTINUE
1107 CONTINUE
     A(1,1)=A(1,1)+CA
     A(1,2)=A(1,2)+V2(3)*SA
     A(1,3)=A(1,3)-V2(2)*SA
     A(2,1)=A(2,1)-V2(3)*SA
     A(2,2)=A(2,2)+CA
     A(2,3)=A(2,3)+V2(1)*SA
     A(3,1)=A(3,1)+V2(2)*SA
     A(3,2)=A(3,2)-V2(1)*SA
     A(3,3)=A(3,3)+CA
     GO TO 97
****
**** Line rotn
****
 108 IF((N+3).GT.KN)GO TO 236
     DO 109 I=1,3
        V1(I)=FN(N+I)
 109 CONTINUE
     N=N+3
     GO TO 102
****
**** Ortholine rotn
****
 110 IF((N+3).GT.KN)GO TO 236
     DO 111 I=1,3
        V3(I)=FN(N+I)
 111 CONTINUE
     N=N+3
     GO TO 103
****
**** Prot
****
 112 IF((N+3).GT.KN)GO TO 236
     DO 113 I=1,3
        V2(I)=FN(N+I)
 113 CONTINUE
     N=N+3
     V2MOD=SQRT(V2(1)*V2(1)+V2(2)*V2(2)+V2(3)*V2(3))
     DO 114 I=1,3
        V2(I)=V2(I)/V2MOD
 114 CONTINUE
     GO TO 106
****
**** Test determinant=+1.0000
****
 115 DET=R(1,1)*(R(2,2)*R(3,3)-R(2,3)*R(3,2))
    *-R(1,2)*(R(2,1)*R(3,3)-R(2,3)*R(3,1))
    *+R(1,3)*(R(2,1)*R(3,2)-R(2,2)*R(3,1))
     IF(ABS(DET-1.000).LT.0.001)GO TO 4
     WRITE(6,116)DET
     IF(DET.LE.-0.999)WRITE(6,117)
     GO TO 4
****
**** Align instruction
****
 118 IF(KL.NE.5)GO TO 236
     IF(FL(1,4).NE.'W')GO TO 236
     ANG=0.
     IF(FL(1,5).EQ.'X')GO TO 119
     ANG=-90.
     IF(FL(1,5).NE.'Y')GO TO 236
 119 CALL ATOMID(2,IAT,NAME,NSZ1)
     CALL ATOMID(3,JAT,NAME,NSZ1)
     IF(IAT.LE.0.OR.JAT.LE.0)GO TO 236
     DO 121 I=1,2
        R1(I)=0.
        R2(I)=0.
        DO 120 J=1,3
           R1(I)=R(I,J)*XO(J,IAT)+R1(I)
           R2(I)=R(I,J)*XO(J,JAT)+R2(I)
 120    CONTINUE
        V1(I)=R2(I)-R1(I)
 121 CONTINUE
     IF(ABS(V1(1))+ABS(V1(2)).GT.1.)GO TO 123
     WRITE(6,122)
     GO TO 4
****
 123 ANG=ATAN2(V1(2),V1(1))*RAD+ANG
     N=0
     L=0
     KL=1
     KN=1
     FN(1)=ANG
     FL(1,1)='Z'
     GO TO 93
****
**** Solid mode
****
 124 ISOL=1
     ISHADE=0
     IF(KL.EQ.1)GO TO 4
     DO 125 I=2,KL
        IF(FL(2,I).EQ.'H')ISHADE=1
        IF(FL(1,I).EQ.'C')ISHADE=2
        IF(FL(2,I).EQ.'K')ISHADE=3
 125 CONTINUE
     IF(KN.EQ.0)GO TO 4
     ANG1=FN(1)
     ANG2=FN(2)
     IF(KN.EQ.2)GO TO 4
     SHADEN=FN(3)
     GO TO 4
****
**** Stick mode
****
 126 ISOL=0
     GO TO 4
****
**** View matrix card
****
 127 IF(KN.LT.9)GO TO 236
     K=0
     DO 1128 I=1,3
        DO 128 J=1,3
           K=K+1
           R(I,J)=FN(K)
 128    CONTINUE
1128 CONTINUE
     N=9
     GO TO 93
****
**** Retrace instruction
****
 129 IF(KN.EQ.0)GO TO 236
     IF(KL.NE.2)GO TO 236
     IF(FL(1,2).EQ.'L')GO TO 130
     IF(FL(1,2).NE.'A')GO TO 236
     ITRACE=INT(FN(1))
     IF(KN.EQ.2)TRSTEP=FN(2)
     GO TO 4
****
 130 ITRACH=INT(FN(1))
     ITRACV=ITRACH
     IF(KN.GE.2)ITRACV=INT(FN(2))
     IF(KN.EQ.3)TRLAB=FN(3)
     GO TO 4
****
**** Label instructions
****
 131 IAL=1
 132 IF(KL.LT.2)GO TO 144
     IF(FL(1,2).EQ.'A'.AND.FL(2,2).EQ.'L'.AND.FL(3,2).EQ.'L')GO TO 144
     IF(FL(1,2).EQ.'N'.AND.FL(2,2).EQ.'O'.AND.FL(3,2).EQ.'N')GO TO 143
     DO 142 K=2,KL
        IF(FL(2,K).NE.'R'.OR.FL(3,K).NE.'I')GO TO 134
        DO 133 I=9,NATO
           ILAB(I)=IAL
 133    CONTINUE
        GO TO 142
****
 134    IF(FL(1,K).NE.'*')GO TO 136
        I=NATO+1
        IF(I.GT.NATOS)GO TO 142
        DO 135 J=I,NATOS
           ILAB(J)=IAL
 135    CONTINUE
        GO TO 142
****
 136    IF(FL(1,K).NE.'&')GO TO 138
        I=NATOS+1
        IF(I.GT.NAT)GO TO 142
        DO 137 J=I,NAT
           ILAB(J)=IAL
 137    CONTINUE
        GO TO 142
****
 138    CALL ATOMID(K,IAT,NAME,NSZ1)
        IF(IAT)139,142,141
 139    DO 140 I=9,NAT
           IF(ITYPE(I).EQ.IAT)ILAB(I)=IAL
 140    CONTINUE
        GO TO 142
****
 141    ILAB(IAT)=IAL
 142 CONTINUE
     GO TO 4
****
 143 IAL=1-IAL
 144 DO 145 I=9,NAT
        ILAB(I)=IAL
 145 CONTINUE
     GO TO 4
****
 146 IAL=0
     GO TO 132
****
**** Put labels where requested
****
 147 L=2
 148 IF(L.GT.KL)GO TO 4
     CALL ATOMID(L,IAT,NAME,NSZ1)
     L=L+1
     IF(L.GT.KL)GO TO 236
     I=0
     IF(FL(1,L).EQ.'A'.AND.FL(2,L).EQ.'U')  I=1
     IF(FL(1,L).EQ.'N'.AND.FL(2,L).EQ.' ')I=4
     IF(FL(1,L).EQ.'N'.AND.FL(2,L).EQ.'E')  I=3
     IF(FL(1,L).EQ.'E'.AND.FL(2,L).EQ.' ')I=2
     IF(FL(1,L).EQ.'S'.AND.FL(2,L).EQ.'E')  I=9
     IF(FL(1,L).EQ.'S'.AND.FL(2,L).EQ.' ')I=8
     IF(FL(1,L).EQ.'S'.AND.FL(2,L).EQ.'W')I=7
     IF(FL(1,L).EQ.'W'.AND.FL(2,L).EQ.' ')I=6
     IF(FL(1,L).EQ.'N'.AND.FL(2,L).EQ.'W')I=5
     IF(I.EQ.0)GO TO 236
     IF(IAT)149,236,151
 149 DO 150 J=9,NAT
        IF(ITYPE(J).EQ.IAT)ILAB(J)=MIN0(ILAB(J),1)*I
 150 CONTINUE
     L=L+1
     GO TO 148
****
 151 ILAB(IAT)=MIN0(ILAB(IAT),1)*I
     L=L+1
     GO TO 148
****
**** Radii card. This sets radii for atoms and bonds. There are several
**** options for bond specification, atom type, intermolecular, to
**** list, specific atom pair.  We also enter number of lines for bond.
**** tapering of bonds may be controlled also, and bond-end plotting.
****
 152 N=0
     IF(FL(1,2).EQ.'B')GO TO 160
     IF(FL(1,2).EQ.'A')GO TO 153
     GO TO 235
****
**** Atom radius specification here
****
 153 IF(KL.EQ.3.AND.FL(3,3).EQ.'L')GO TO 158
     DO 157 K=3,KL
        CALL ATOMID(K,IAT,NAME,NSZ1)
        IF(IAT)154,157,156
 154    M=IAT
        N=N+1
        DO 155 I=9,NAT
           IF(ITYPE(I).EQ.M)RADI(I)=FN(N)
 155    CONTINUE
        GO TO 157
****
 156    N=N+1
        RADI(IAT)=FN(N)
 157 CONTINUE
     GO TO 4
****
 158 DO 159 I=9,NAT
        RADI(I)=FN(1)
 159 CONTINUE
     GO TO 4
****
**** Bond specification here.
****
 160 J1=FL(1,3)
     J2=FL(2,3)
     J3=FL(3,3)
     IF(J1.EQ.'T'.AND.J2.EQ.'O')GO TO 161
     IF(J1.EQ.'A'.AND.J3.EQ.'L')GO TO 171
     IF(J1.EQ.'I'.AND.J3.EQ.'T')GO TO 162
     IF(J1.EQ.'T'.AND.J3.EQ.'P')GO TO 169
     IF(J1.EQ.'E'.AND.J2.EQ.'N')GO TO 170
     IF(J1.EQ.'N'.AND.J2.EQ.'O')GO TO 172
     CALL ATOMID(3,IAT,NAME,NSZ1)
     CALL ATOMID(4,JAT,NAME,NSZ1)
     IF(IAT.LE.0.OR.JAT.LE.0)GO TO 236
****
**** Specific bond named here
****
     IN1=MIN0(IAT,JAT)
     IN2=MAX0(IAT,JAT)
     GO TO 163
****
**** Keyword to  followed by atom or atom type
****
 161 CALL ATOMID(4,M,NAME,NSZ1)
     IF(M.EQ.0)GO TO 236
     IN1=0
     IN2=M
     GO TO 163
****
**** Keyword inter for all intermolecular bonds
****
 162 IN1=-1
     IN2=0
****
**** Store bond radius and number of lines.
****
 163 RB=RBDEF
     L=LBDEF
     IF(KN.GT.0)RB=FN(1)
     IF(KN.EQ.2)L=INT(FN(2))
     RB=RB*1000.
     IN3=1000*L+INT(RB+0.5)
     IF(NSPEC.EQ.0)GO TO 165
     DO 164 I=1,NSPEC
        IF(IN1.EQ.IBS(I,1).AND.IN2.EQ.IBS(I,2))GO TO 166
 164 CONTINUE
 165 IF(NSPEC.GE.30)GO TO 167
     NSPEC=NSPEC+1
     I=NSPEC
     IBS(I,1)=IN1
     IBS(I,2)=IN2
 166 IBS(I,3)=IN3
     GO TO 4
****
 167 WRITE(6,168)
     GO TO 4
****
**** Tapering
****
 169 TAPER=FN(1)
     GO TO 4
****
**** Bond-end plotting
****
 170 IEND=1
     IF(KL.EQ.4.AND.FL(1,4).EQ.'N')IEND=0
     GO TO 4
****
**** Change default settings for radius and lines
****
 171 NSPEC=0
 172 RBDEF=FN(1)
     LBDEF=INT(FN(2))
     GO TO 4
****
**** Packing diagram control
****
 173 I=0
     IF(KL.EQ.2)GO TO 174
     IF(FL(1,3).NE.'C')GO TO 236
     CALL ATOMID(4,I,NAME,NSZ1)
     IF(I.LE.0)GO TO 236
****
**** Pack  range     x1,x2,y1,y2,z1,z2
****
 174 CONTINUE
     IUNIQ=0
     INTER=0
     IPRINT=0
     CALL DSCAN(I,IUNIQ,INTER,IPRINT,NAME,X,XO,RADI,INCL,ILAB,ITYPE,
    *   IC,XP,YP,ZP,RP,MOL,IDONE,IFIX,INEXT,NSZ1,NSZ2,NSZ3)
     GO TO 4
****
**** Moles to be plotted
****
 175 IF(KL.GT.1.AND.FL(1,2).EQ.'N')GO TO 177
     IF(KL.GT.1.AND.FL(1,2).EQ.'U')GO TO 178
     IF(KN.LT.4)GO TO 236
     DO 176 K=1,KN,4
        IF(NMOL.GE.NSZ1)GO TO 179
        NMOL=NMOL+1
        MOL(1,NMOL)=INT(FN(K))
        MOL(2,NMOL)=INT(FN(K+1))
        MOL(3,NMOL)=INT(FN(K+2))
        MOL(4,NMOL)=INT(FN(K+3))
 176 CONTINUE
     GO TO 4
****
 177 NMOL=0
     GO TO 4
****
 178 NMOL=NMOL1
     GO TO 4
****
 179 WRITE(6,180)
     GO TO 4
****
**** Include / omit
****
 181 N=-1
     GO TO 183
****
 182 N=1
 183 IF(FL(1,2).EQ.'A'.AND.FL(2,2).EQ.'L'.AND.FL(3,2).EQ.'L')GO TO 199
     IF(FL(1,2).EQ.'N'.AND.FL(2,2).EQ.'O'.AND.FL(3,2).EQ.'N')GO TO 198
     IF(FL(1,2).EQ.'O'.AND.FL(2,2).EQ.'U'.AND.FL(3,2).EQ.'T')GO TO 195
     DO 1194 K=2,KL
        IF(FL(1,K).NE.'*')GO TO 186
        M=NATO+1
        IF(M.GT.NATOS)GO TO 1194
        DO 185 I=M,NATOS
           INCL(I)=N*IABS(INCL(I))
 185    CONTINUE
        GO TO 1194
****
 186    IF(FL(1,K).NE.'&')GO TO 188
        M=NATOS+1
        IF(M.GT.NAT)GO TO 1194
        DO 187 I=M,NAT
           INCL(I)=N*IABS(INCL(I))
 187    CONTINUE
        GO TO 1194
****
 188    IF(FL(2,K).NE.'R'.OR.FL(3,K).NE.'I')GO TO 190
        DO 189 I=9,NATO
           INCL(I)=N*IABS(INCL(I))
 189    CONTINUE
        GO TO 1194
****
 190    CALL ATOMID(K,M,NAME,NSZ1)
        IF(M) 191,1194,193
 191    DO 192 I=9,NAT
           IF(ITYPE(I).EQ.M) INCL(I)=N*IABS(INCL(I))
 192    CONTINUE
        GO TO 1194
****
 193    INCL(M)=N*IABS(INCL(M))
1194 CONTINUE
     GO TO 4
****
 195 IF(KN.EQ.1.AND.ABS(FN(1)).LE.1.0E-06)GO TO 197
     IF(KN.NE.6)GO TO 236
     DO 196 I=1,6
        ENC(I)=FN(I)
 196 CONTINUE
     IENC=1
     GO TO 4
****
 197 IENC=0
     GO TO 4
****
 198 N=-N
 199 DO 200 I=1,NAT
        INCL(I)=N*IABS(INCL(I))
 200 CONTINUE
     GO TO 4
****
**** Unitcell to be plotted
****
 201 ICELL=1
     IF(KL.GT.1.AND.FL(1,2).EQ.'N')ICELL=0
     GO TO 4
****
**** Stereo
****
 202 ISTER=0
     IF(J1.EQ.'S')ISTER=1
     IF(J1.EQ.'M')IPERS=1
     IF(KL.GT.1.AND.FL(1,2).EQ.'C')IPLOTR=4
     IF(KN.EQ.0)GO TO 4
     DPLOT=FN(1)
     GO TO 4
****
**** Size control...size of drawing, scale, characters, box
****
 203 IF(KN.NE.KL)GO TO 236
     SIZEM=FN(1)
     IF(SIZEM.GE.275.0)SIZEM=275.0
     IF(KL.LT.2)GO TO 4
     DO 204 K=2,KL
        IF(FL(1,K).EQ.'S')SCA=FN(K)
        IF(FL(1,K).EQ.'T')TSIZE=FN(K)
        IF(FL(1,K).EQ.'B')SHRINK=FN(K)/100.
        IF(FL(1,K).EQ.'C')CHSIZE=FN(K)
 204 CONTINUE
     GO TO 4
****
**** Plotstep size
****
 205 IF(KN.NE.1)GO TO 236
     PLSTEP=FN(1)
     GO TO 4
****
**** Print options
****
 206 IN1=0
     IN2=0
     IN3=0
     IN4=0
     IF(KL.GT.1)GO TO 207
     IN1=1
     IN2=1
     IN3=1
     IN4=1
     GO TO 209
****
 207 DO 208 I=2,KL
        IF(FL(1,I).EQ.'A')IN1=1
        IF(FL(1,I).EQ.'B')IN2=1
        IF(FL(1,I).EQ.'R')IN3=1
        IF(FL(1,I).EQ.'M')IN4=1
 208 CONTINUE
 209 IF(IN1.EQ.0)GO TO 213
     WRITE(6,210)
     DO 212 I=9,NAT
        IF(INCL(I).EQ.0)GO TO 212
        J1=' '
        IF(INCL(I).GT.0)J1='*'
        J2=' '
        IF(ILAB(I).GT.0)J2='*'
        IJ3=-ITYPE(I)
        IN1=IJ3/1000
        IJ3=MOD(IJ3,1000)
        WRITE(6,211)(NAME(K,I),K=1,6),(X(K,I),K=1,3),RADI(I),J1,J2,
    *      LET(IN1),LET(IJ3)
 212 CONTINUE
 213 IF(IN2.EQ.0)GO TO 217
     WRITE(6,214)
     IF(NC.EQ.12)GO TO 229
     DO 216 K=13,NC
        I=IC(K)/1000
        J=MOD(IC(K),1000)
        WRITE(6,215)(NAME(L,I),L=1,6),(NAME(L,J),L=1,6)
 216 CONTINUE
 217 IF(IN3.EQ.0)GO TO 229
     WRITE(6,218)
     WRITE(6,219)RBDEF,LBDEF
     IF(NSPEC.EQ.0)GO TO 229
     DO 228 K=1,NSPEC
        L=IBS(K,3)
        I=L/1000
        RB=0.001*FLOAT(MOD(L,1000))
        IN1=IBS(K,1)
        IF(IN1)220,222,226
 220    WRITE(6,221)RB,I
        GO TO 228
****
 222    IN2=IBS(K,2)
        IF(IN2.GT.0)GO TO 224
        IN2=-IN2
        IN1=IN2/1000
        IN2=MOD(IN2,1000)
        WRITE(6,223)LET(IN1),LET(IN2),RB,I
        GO TO 228
****
 224    WRITE(6,225)(NAME(J,IN2),J=1,6),RB,I
        GO TO 228
****
 226    WRITE(6,227)(NAME(J,IN1),J=1,6),(NAME(J,IN2),J=1,6),RB,I
 228 CONTINUE
 229 IF(IN4.EQ.0)GO TO 232
     WRITE(6,230)
     IF(NMOL.EQ.0)GO TO 232
     WRITE(6,231)((MOL(J,I),J=1,4),I=1,NMOL)
 232 WRITE(6,233)
     GO TO 4
****
**** Plot .... this card may contain the number of copies of
**** the drawing to be made.
****
 234 IF(KL.GT.1.AND.FL(1,2).EQ.'C')ICOPY=INT(FN(1))
     IPLOT=IPLOT+1
     READ(IN,5,END=247)COL
     IF(COL(1).EQ.'E'.AND.COL(2).EQ.'N'.AND.COL(3).EQ.'D')THEN
        IBEG=-1
     ELSE
        BACKSPACE 10
     ENDIF
     GO TO 238
****
**** General error message
****
 235 CONTINUE
 236 IERR=IERR+1
     WRITE(6,260)COL
     WRITE(6,237)
     GO TO 4
****
 238 IF(IERR.GT.0)WRITE(6,239)
     IF(IERR.EQ.0)RETURN
     IF(IERR-2)240,242,244
 240 WRITE(6,241)
     GO TO 246
****
 242 WRITE(6,243)
     GO TO 246
****
 244 WRITE(6,245)
 246 IERR=0
     STOP 16
****
**** End of job
****
 247 FL(1,1)='='
     GO TO 249
****
 248 IF(IN.EQ.10)GO TO 247
     IN=10
     GO TO 4
****
 249 RETURN
****
   5 FORMAT(80A1)
   6 FORMAT('0---',80A1)
  13 FORMAT('0*** Unrecognized instruction - Ignored ***',//)
  15 FORMAT('0...',80A1)
  31 FORMAT('0*** Symmetry list full: Ignored',//)
  47 FORMAT('0*** Atom list full: Ignored',//)
  65 FORMAT('0*** Connections list full',//)
 116 FORMAT('0*** Warning: Did you know that the determinant of your ',
    *       'view matrix =',F10.5/4X,'It should be +1 to be legal',//)
 117 FORMAT('0*** In fact, your determinant represents an inversion.',/
    *       '    Absolute configuration is changed. ',
    *       ' You have beem warned...',//)
 122 FORMAT('0*** Atoms superimposed in this view: ',
    *       'View matrix not changed')
 168 FORMAT('0*** Special bond list full: Ignored',//)
 180 FORMAT('0*** Molecule list full')
 210 FORMAT('0Atoms',/,'0   Name',7X,'x',9X,'y',9X,'z',6X,
    *       'Radius  Include  Label  Type',//)
 211 FORMAT(4X,6A1,3F10.5,F7.2,5X,A1,7X,A1,5X,2A1)
 214 FORMAT('0Bonds',//)
 215 FORMAT(4X,6A1,'--',6A1)
 218 FORMAT('0Bonds',12X,'Radius  Lines',/,
    *       '+____________________________')
 219 FORMAT('0Normal',11X,F6.3,I7)
 221 FORMAT('0Intermolecular',F9.3,I7)
 223 FORMAT(' To ',2A1,F18.3,I7)
 225 FORMAT(' To ',6A1,F14.3,I7)
 227 FORMAT(1X,6A1,'--',6A1,F9.3,I7)
 230 FORMAT('0Molecules',/)
 231 FORMAT(4(4I4,2X))
 233 FORMAT('0')
 260 FORMAT('0**** ',80A1)
 237 FORMAT('0*** Instruction error...Check for correct spelling of',
    *       ' keywords and sufficient data.',//)
 239 FORMAT('0*** Error(s) found in instructions - No plotting ***',/,
    *       '0*** Check for data cards ignored above ***')
 241 FORMAT('0*** Better luck next time ***')
 243 FORMAT('0*** It''s not your day, is it? ***')
 245 FORMAT('0*** When did you last read the blurb? ***')
****
     END
****
     SUBROUTINE ATOMID(K,IAT,NAME,NSZ1)
****
**** Finds which atom (serial number) has name fl(k,...)
****
     CHARACTER FL,COL,LET,NAME,N1,N2,N3
****
     DIMENSION NAME(6,NSZ1)
****
     COMMON /AAA   / NAT,NATOS,NATO,NC,NC1,IERR,IPLOT
     COMMON /FRC   / COL(80),FL(6,40)
     COMMON /ALPHA / LET(27)
****
     N1=FL(1,K)
     IF(N1.EQ.':')GO TO 4
     N2=FL(2,K)
     N3=FL(3,K)
     IF(N2.EQ.'('.OR.N3.EQ.'(')GO TO 6
     IF(N2.GE.'0'.AND.N2.LE.'9')GO TO 6
     IF(N3.GE.'0'.AND.N3.LE.'9')GO TO 6
****
**** No number attached to atom element symbol.
**** This causes a characteristic number to be generated from the
**** literal values of the symbol. This will be used for
**** identification of atom type.
****
     I2=0
     I1=0
     DO 1 I=1,27
        IF(N1.EQ.LET(I))I1=I
        IF(N2.EQ.LET(I))I2=I
   1 CONTINUE
     IF(I1.GT.0.AND.I2.GT.0)GO TO 3
     WRITE(6,2)N1,N2
     GO TO 10
****
   3 IAT=-(1000*I1+I2)
     GO TO 11
****
   4 DO 5 I=1,5
        FL(I,K)=FL(I+1,K)
   5 CONTINUE
     FL(6,K)=LET(27)
****
**** Search list of atoms for this name
****
   6 DO 8 I=1,NAT
        DO 7 L=1,6
           IF(NAME(L,I).NE.FL(L,K))GO TO 8
   7    CONTINUE
        IAT=I
        GO TO 11
****
   8 CONTINUE
****
**** Unrecognised atom name : returns iat=0
**** and increments error counter
****
     WRITE(6,9)(FL(L,K),L=1,6)
  10 IERR=IERR+1
     IAT=0
  11 RETURN
****
   2 FORMAT('0*** Error - Unrecognised atom type...',2A1,//)
   9 FORMAT('0*** Error - Atom name not in list...',6A1,//)
****
     END
****
     SUBROUTINE FREDA(IMIN,IMAX)
****
**** Free-format reading routine.
**** Returns kn numbers in fn, kl literals in fl
****
     CHARACTER FL,COL,ICH,INUM
****
     COMMON /FRC   / COL(80),FL(6,40)
     COMMON /FRN   / FN(40),NCHAR,KN,KL
     COMMON /IO    / IN
****
     DIMENSION INUM(10)
****
     DATA INUM/'1','2','3','4','5','6','7','8','9','0'/
****
     KN=0
     KL=0
     I=IMIN-1
****
**** Start of a new field
**** Look for a non-blank column
****
   1 A=0.0
     IP=0
     P=1.
     L=0
     S=1.0
   2 I=I+1
     IF(I.GT.IMAX)GO TO 8
     ICH=COL(I)
     IF(L.EQ.0.AND.ICH.EQ.' ')GO TO 2
****
**** Start of a field
****
     L=L+1
     DO 3 J=1,10
        IF(ICH.EQ.INUM(J))GO TO 4
   3 CONTINUE
     IF(ICH.EQ.'.')GO TO 5
     IF(ICH.EQ.'+')GO TO 6
     IF(ICH.EQ.'-')GO TO 7
     IF(ICH.EQ.'=')GO TO 16
     IF(L.GT.1)GO TO 9
     GO TO 10
****
**** Numeric field found
****
   4 IF(J.EQ.10)J=0
     IF(IP.EQ.1)P=P*0.1
     A=10.0*A+FLOAT(J)
     GO TO 2
****
   5 IP=1
     GO TO 2
****
   6 IF(L.GT.1)GO TO 9
     S=1.0
     GO TO 2
****
   7 IF(L.GT.1)GO TO 9
     S=-1.0
     GO TO 2
****
   8 IF(L.GT.0)GO TO 9
     RETURN
****
**** End of numeric field
****
   9 A=S*A*P
     IF(KN.GE.40)GO TO 20
     KN=KN+1
     FN(KN)=A
     IF(ICH.EQ.'+'.OR.ICH.EQ.'-'.OR.ICH.EQ.'=')I=I-1
     GO TO 1
****
**** Literal field
****
  10 IF(KL.GE.40)GO TO 22
     KL=KL+1
  11 FL(L,KL)=ICH
     L=L+1
     IF(L.GT.NCHAR)GO TO 13
     I=I+1
     IF(I.GT.IMAX)GO TO 14
     ICH=COL(I)
     IF(ICH.EQ.' ')GO TO 14
     GO TO 11
****
  13 I=I+1
     IF(I.GT.IMAX)RETURN
     IF(COL(I).EQ.' ')GO TO 1
     GO TO 13
****
**** End of literal field defined by blank
****
  14 DO 15 J=L,NCHAR
        FL(J,KL)=' '
  15 CONTINUE
     GO TO 1
****
**** Continuation card
****
  16 IF(L.GT.1)GO TO 9
     READ(IN,17)COL
     WRITE(6,18)COL
     I=1
     IMAX=80
     GO TO 1
****
**** Errors
****
  20 WRITE(6,21)
     RETURN
****
  22 WRITE(6,23)
     RETURN
****
  17 FORMAT(80A1)
  18 FORMAT(' ===',80A1)
  21 FORMAT('0*** Too many numbers given: only first 40 accepted',//)
  23 FORMAT('0*** Too many literals given: only first 40 accepted',//)
****
     END
****
     SUBROUTINE SYMFRE(COL,RS,NSYM,IERR)
****
**** Free-format reading routine for symm cards
****
     CHARACTER COL(80),INUM,ICH
****
     DIMENSION RS(24,3,4)
     DIMENSION NUM(10),INUM(10)
****
     DATA NUM/1,2,3,4,5,6,7,8,9,0/
     DATA INUM/'1','2','3','4','5','6','7','8','9','0'/
****
     DO 1 I=1,80
        IF(COL(I).EQ.' ')GO TO 2
   1 CONTINUE
   2 IMAX=80
     NS=NSYM
   3 NS=NS+1
     IF(NS.GT.24)GO TO 20
     NOP=1
     DO 1114 J=1,3
        DO 4 K=1,4
           RS(NS,J,K)=0.0
   4    CONTINUE
1114 CONTINUE
   5 S=1.0
     T=0.0
     IP=0
     P=1.
     IFOUND=0
   6 I=I+1
     IF(I.GT.IMAX)GO TO 18
     ICH=COL(I)
     IF(ICH.EQ.' ')GO TO 6
     IF(ICH.EQ.','.OR.ICH.EQ.'*')GO TO 18
     IFOUND=1
     IF(ICH.EQ.'X')GO TO 11
     IF(ICH.EQ.'Y')GO TO 12
     IF(ICH.EQ.'Z')GO TO 13
     IF(ICH.EQ.'+')GO TO 15
     IF(ICH.EQ.'-')GO TO 16
     IF(ICH.EQ.'.')GO TO 17
     DO 7 K=1,10
        IF(ICH.EQ.INUM(K))GO TO 9
   7 CONTINUE
     WRITE(6,8)ICH
     IERR=1
     GO TO 6
****
   9 A=NUM(K)
     IF(IP.EQ.1)GO TO 10
     T=10.0*T+A
     GO TO 6
****
  10 P=P*0.1
     T=T+A*P
     GO TO 6
****
  11 J=1
     GO TO 14
****
  12 J=2
     GO TO 14
****
  13 J=3
  14 RS(NS,NOP,J)=S
     S=1.0
     GO TO 6
****
  15 S=1.0
     GO TO 6
****
  16 S=-1.0
     GO TO 6
****
  17 IP=1
     GO TO 6
****
  18 T=T*S
     RS(NS,NOP,4)=T
     IF(IFOUND.EQ.0.AND.I.LE.IMAX)WRITE(6,19)
     IF(I.GT.IMAX)GO TO 22
     NOP=NOP+1
     IF(NOP.LE.3)GO TO 5
     GO TO 3
****
  20 WRITE(6,21)
     GO TO 24
****
  22 IF(NOP.EQ.1.AND.IFOUND.EQ.0)GO TO 24
     IF(NOP.EQ.3.AND.IFOUND.EQ.1)GO TO 25
     IERR=1
     WRITE(6,23)
  24 NS=NS-1
  25 NSYM=NS
     RETURN
****
   8 FORMAT('0*** Error - invalid character...',A1,//)
  19 FORMAT('0*** Error - blank operator field',//)
  21 FORMAT('0*** Symm list full',//)
  23 FORMAT('0*** Error - last general position is incomplete',//)
****
     END
****
     BLOCK DATA ALPHABET
****
     COMMON /ALPHA / LET(27)
****
     CHARACTER LET
****
     DATA LET/'A','B','C','D','E','F','G','H','I','J','K','L','M',
    *         'N','O','P','Q','R','S','T','U','V','W','X','Y','Z',' '/
****
     END
****
     SUBROUTINE ZDRAW(I,X,Y)
****
**** Control of pen
**** i=1 means move to (x,y)
**** i=2 means draw to (x,y)
****
     J=4-I
     CALL PLOT(X,Y,J)
     RETURN
****
     END
****
     SUBROUTINE ZENDER(IEND,IPLOT,IBEGIN)
****
**** Called at end of each picture
****
     IF(IEND.GE.0)THEN
        IF(IBEGIN.LT.0)THEN
           CALL PLOT(0.,0.,999)
        ELSE IF(IEND.EQ.0)THEN
           CALL PLOT(0.0,0.0,-999)
           CALL PLOT(0.2,0.2,-3)
        ELSE
           IF(IPLOT.EQ.0)STOP
        ENDIF
     ELSE
        CALL PLOT(0.,0.,999)
     ENDIF
     RETURN
****
     END
****
     SUBROUTINE ZMARK
****
**** To put a cross at the current pen position
****
     CALL WHERE(X,Y,FACT)
     ISYMB=3
     CALL SYMBOL(X,Y,5.,CHAR(ISYMB),0.,-1)
     RETURN
****
     END
****
     SUBROUTINE ZSETPN(I)
****
**** To set pen or colour for stereo colour plots.
**** i=1 for left-eye view
**** i=2 for right-eye view
****
     CALL NEWPEN(I)
****
     RETURN
****
     END
****
     SUBROUTINE ZSETUP(YLIMIT,EYESEP,RATIO,NPLOT)
****
**** Called at beginning of program to initialise plot
**** routines and set up defaults.
**** Ylimit is max. Possible width of plot, pldef is plotter resolution
**** used (changed by segment instruction), trdef is radial decrement (
**** for retracing atoms, tldef is step for retracing labels,
**** 2*eyesep is eye separation(mm), rbond and lbond are
**** defaults for bond radii and no. of lines, radat is default for ato
**** radii (angstroms), size is default for plot size (mm), char is def
**** for character height (mm), dist is default for view distance (mm),
**** title is default for height of title (mm), angle1 and angle2 are
**** defaults for shading parameters, shade is default for shading dens
**** (mm), taper is default for tapering of bonds, ratio is width of
**** characters divided by height.
****
     COMMON /DEF   / RADBON,LINBON,RADAT,SIZE,CHAR,DIST,TITLE,RBOND,
    *                LBOND,ANGLE1,ANGLE2,SHADE,TAPER,TLDEF,TRDEF,PLDEF
****
     YLIMIT=175.0
     PLDEF=0.127
     TRDEF=0.1
     TLDEF=0.1
     EYESEP=30.
     RBOND=0.04
     LBOND=8
     RADBON=RBOND
     LINBON=LBOND
     RADAT=0.3
     SIZE=200.
     CHAR=3.
     DIST=600.
     TITLE=3.
     ANGLE1=120.
     ANGLE2=-45.
     SHADE=0.75
     TAPER=0.375
     RATIO=1.0
     CALL PLOTS(3,1,'plots.pds',9)
     CALL PLOT(0.2,0.2,-3)
     IF(NPLOT.GT.0)PLDEF=0.05
     REWIND 3
     CALL FACTOR(0.03937)
     RETURN
****
     END
****
     SUBROUTINE ZSPEC(YLIM,IFOUT)
****
     COMMON /FRC   / COL(80),FL(6,40)
     COMMON /FRN   / FN(40),NCHAR,KN,KL
     COMMON /IO    / IN
****
     CHARACTER FL,COL
****
**** Called by a 'data special....' card.
**** Ylim is the max. permitted width of plot (y direction).
**** Col contains the current input card (80A1)
**** Fl contains the kl words on the card (excluding 'data')
**** each word
**** Up to 6 characters, one in each element (A1 format).
**** Fn contains the kn numbers on the card.
**** Nchar=6
****
     KM=KL-KN
     IF(KM.NE.1)GO TO 20
     DO 10 I=2,KL
        IF(FL(1,I).EQ.'Y'.AND.FL(2,I).EQ.'L'.AND.FL(3,I).EQ.'I')
    *      GO TO 40
        IF(FL(1,I).EQ.'P'.AND.FL(2,I).EQ.'A'.AND.FL(3,I).EQ.'R')
    *      GO TO 50
        IF(FL(1,I).EQ.'A'.AND.FL(2,I).EQ.'T'.AND.FL(3,I).EQ.'O')
    *      GO TO 60
        IF(FL(1,I).EQ.'P'.AND.FL(2,I).EQ.'E'.AND.FL(3,I).EQ.'N')
    *      GO TO 70
        GO TO 10
****
  40    YLIM=FN(I-1)
        IF(YLIM.GE.175.0)YLIM=175.0
        WRITE(6,1000)YLIM
        GO TO 10
****
  50    IN=INT(FN(I-1))
        WRITE(6,1001)IN
        GO TO 10
****
  60    NSZ1=INT(FN(I-1))
        WRITE(6,1002)NSZ1
        GO TO 10
****
  70    IPEN=INT(FN(I-1))
        IF(IPEN.LT.1)IPEN=1
        IF(IPEN.GT.5)IPEN=5
        CALL NEWPEN(IPEN)
  10 CONTINUE
     GO TO 30
****
  20 IFOUT=1
  30 RETURN
****
1000 FORMAT('0Special option used, Y plotting limit is set to',F10.4,
    *' mm')
1001 FORMAT('0Special option used, input unit parameter is set to',I5)
1002 FORMAT('0Special option used, array sizes are set to a maximum of'
    *,I5,2X,' atoms')
****
     END
****
     SUBROUTINE ZWRITE(ITEXT,I,SIZE)
****
**** To plot text.
**** Itext is an array
**** Each element contains one character (a1 format)
**** I is number of elements in array
**** Size is height of characters in mm.
****
     DIMENSION ITEXT(I)
****
     CHARACTER ITEXT
****
     CALL WHERE(X,Y,FACT)
     CALL SYMBOL(X,Y,SIZE,ITEXT,0.,I)
****
     RETURN
****
     END
