
****
****
**** Preprogram for variable array dimensioning in PLUTO 81-11-03
**** Originally written in IBM PL/I, Fortran version 25-11-92
****
**** Files used:
****   Unit 1   = Temporary file used as input to transfer the input
****              data to the main part of the program
****   Unit 2   = Temporary file used as input file to the Fortran
****              Compiler
****   Unit 5   = Inputdata file created prior to the run of ORTP89
****
     COMMON/MESG  /BUFA
     COMMON/FRFL  /IFL(10)
     COMMON/FRFN  /FN(10),KL,KN,IN(3,10)
****
     DIMENSION IBUFA(80),FL(6,10),IFLB(2,10)
****
     CHARACTER FL,IBUFA,BUFA*80,IFL*6,IFLB*3
****
     EQUIVALENCE (IBUFA,BUFA),(IFL,FL,IFLB)
****
     NSZ1=200
     NSZ2=0
     NSZ3=0
****
**** Read first line of data input file to test if number of atoms is
**** specified. Default is 200 atoms. If NATOM negative atom parameters
**** will be read from a separate atom parameter file.
****
     READ(5,1000)BUFA
     NR=-3
     CALL FLINP2(NR,MIXUP)
     DO 10 J=1,KL
        IF(IFLB(1,J).EQ.'ATO')THEN
           NSZ1=INT(FN(J-2))
        ENDIF
  10 CONTINUE
****
**** Write first line to output file. This file is used as input
**** to ORTEP itself.
****
     WRITE(1,1000)BUFA
****
**** Copy rest of data input file to the output file
****
  20 READ(5,1000,END=30)BUFA
     WRITE(1,1000)BUFA
     GO TO 20
****
**** Calculate array sizes from number of atoms specified in line 1 of
**** the data input file
****
  30 NSZ2=5*NSZ1
     NSZ3=10*NSZ1
****
**** Write source of mainprogram to the input file for the compiler
****
     WRITE(2,1200)NSZ1
     WRITE(2,1300)NSZ1
     WRITE(2,1400)NSZ1
     WRITE(2,1500)NSZ1
     WRITE(2,1600)NSZ1
     WRITE(2,1700)NSZ1
     WRITE(2,1800)NSZ1
     WRITE(2,1900)NSZ2
     WRITE(2,2000)NSZ3
     WRITE(2,2100)NSZ3
     WRITE(2,2200)NSZ3
     WRITE(2,2300)NSZ3
     WRITE(2,2400)NSZ3
     WRITE(2,2500)NSZ1
     WRITE(2,2600)NSZ1
     WRITE(2,2700)NSZ1
     WRITE(2,2800)NSZ1
     WRITE(2,2900)NSZ1
     WRITE(2,3000)NSZ1
     WRITE(2,3100)NSZ1
     WRITE(2,3200)NSZ1
     WRITE(2,3300)NSZ1
     WRITE(2,3400)NSZ1
     WRITE(2,3500)NSZ1
     WRITE(2,3600)NSZ1
     WRITE(2,3700)NSZ1
     WRITE(2,3800)
     WRITE(2,3900)
     WRITE(2,4000)
     WRITE(2,4100)NSZ1
     WRITE(2,4200)NSZ2,NSZ3
     WRITE(2,4300)
     WRITE(2,4400)
     REWIND 2
     STOP
****
1000 FORMAT(A80)
1200 FORMAT(5X,' DIMENSION NAME(6,',I10,')')
1300 FORMAT(5X,' DIMENSION X(3,',I10,')')
1400 FORMAT(5X,' DIMENSION XO(3,',I10,')')
1500 FORMAT(5X,' DIMENSION RADI(',I10,')')
1600 FORMAT(5X,' DIMENSION INCL(',I10,')')
1700 FORMAT(5X,' DIMENSION ILAB(',I10,')')
1800 FORMAT(5X,' DIMENSION ITYPE(',I10,')')
1900 FORMAT(5X,' DIMENSION IC(',I10,')')
2000 FORMAT(5X,' DIMENSION XP(',I10,')')
2100 FORMAT(5X,' DIMENSION YP(',I10,')')
2200 FORMAT(5X,' DIMENSION ZP(',I10,')')
2300 FORMAT(5X,' DIMENSION RP(',I10,')')
2400 FORMAT(5X,' DIMENSION MOL(4,',I10,')')
2500 FORMAT(5X,' DIMENSION XL(',I10,')')
2600 FORMAT(5X,' DIMENSION YL(',I10,')')
2700 FORMAT(5X,' DIMENSION XPS(',I10,')')
2800 FORMAT(5X,' DIMENSION YPS(',I10,')')
2900 FORMAT(5X,' DIMENSION RPS(',I10,')')
3000 FORMAT(5X,' DIMENSION XRAT(',I10,')')
3100 FORMAT(5X,' DIMENSION YRAT(',I10,')')
3200 FORMAT(5X,' DIMENSION RAT(',I10,')')
3300 FORMAT(5X,' DIMENSION RATY(',I10,')')
3400 FORMAT(5X,' DIMENSION IDONE(',I10,')')
3500 FORMAT(5X,' DIMENSION IFIX(',I10,')')
3600 FORMAT(5X,' DIMENSION INEXT(',I10,')')
3700 FORMAT(5X,' DIMENSION IOBSC(',I10,')')
3800 FORMAT(5X,' CHARACTER NAME')
3900 FORMAT(5X,' CALL PLUT89(NAME,X,XO,RADI,INCL,ILAB,ITYPE,IC,')
4000 FORMAT(5X,'*XP,YP,ZP,RP,MOL,XL,YL,XPS,YPS,RPS,XRAT,YRAT,')
4100 FORMAT(5X,'*RAT,RATY,IDONE,IFIX,INEXT,IOBSC,',I10,',')
4200 FORMAT(5X,'*',I10,',',I10,')')
4300 FORMAT(5X,' STOP')
4400 FORMAT(5X,' END')
****
     END
****
       SUBROUTINE FLINP2(NR,MIXUP)
****
****   FREE-FORMAT READING ROUTINE.
****   RETURNS KN NUMBERS IN FNI, KL LITERALS IN FL
****
       COMMON/MESG  /BUFA
       COMMON/FRFL  /IFL(10)
       COMMON/FRFN  /FN(10),KL,KN,IN(3,10)
****
       DIMENSION INUM(10),IBUFA(80),FL(6,10)
****
       CHARACTER FL,IBUFA,INUM,ICH,BUFA*80,IFL*6
****
       EQUIVALENCE (IBUFA,BUFA),(IFL,FL)
****
       DATA INUM/'1','2','3','4','5','6','7','8','9','0'/
****
       ITEST=NR
       NRT=IABS(NR)
       DO 35 I=1,10
          FN(I)=0.0
          DO 40 J=1,6
             FL(J,I)=' '
  40      CONTINUE
          DO 45 K=1,3
             IN(K,I)=0
  45      CONTINUE
  35   CONTINUE
       MIXUP=1
  25   KN=0
       NF=0
       KL=0
       I=0
****
****   START OF A NEW FIELD
****   LOOK FOR A NON-BLANK COLUMN
****
   1   A=0.0
       IP=0
       P=1.
       L=0
       S=1.0
   2   I=I+1
       IF(I.GT.80)GO TO 8
       ICH=IBUFA(I)
       IF(L.EQ.0.AND.ICH.EQ.' ')GO TO 2
****
****   START OF A FIELD
****
       L=L+1
       DO 3 J=1,10
          IF(ICH.EQ.INUM(J))GO TO 4
   3   CONTINUE
       IF(ICH.EQ.'.')GO TO 5
       IF(ICH.EQ.'+')GO TO 6
       IF(ICH.EQ.'-')GO TO 7
       IF(ICH.EQ.'=')GO TO 16
       IF(L.GT.1)GO TO 9
       GO TO 10
****
****   NUMERIC FIELD FOUND
****
   4   IF(J.EQ.10)J=0
       NF=NF+1
       IF(IP.EQ.1)P=P*0.1
       A=10.0*A+J
       GO TO 2
****
   5   IP=1
       GO TO 2
****
   6   IF(L.GT.1)GO TO 9
       S=1.0
       GO TO 2
****
   7   IF(L.GT.1)GO TO 9
       S=-1.0
       GO TO 2
****
   8   IF(L.GT.0)GO TO 9
       GO TO 19
****
****   END OF NUMERIC FIELD
****
   9   A=S*A*P
       IF(KN.GE.10)GO TO 20
       KN=KN+1
       FN(KN)=A
       IF(KL.EQ.0)GOTO 18
       IN(NF,KL)=1
  18   IF(NF.EQ.2)NF=0
       IF(ICH.EQ.'+'.OR.ICH.EQ.'-'.OR.ICH.EQ.'=')I=I-1
       GO TO 1
****
****   LITERAL FIELD
****
  10   IF(KL.GE.10)GO TO 22
       KL=KL+1
  11   FL(L,KL)=ICH
       IF(ICH.NE.'/')GOTO 114
       KN=KN+1
       IN(3,KN)=1
       GOTO 14
****
 114   L=L+1
       IF(L.GT.6)GO TO 13
       I=I+1
       IF(I.GT.80)GO TO 14
       ICH=IBUFA(I)
       IF(ICH.EQ.' ')GO TO 14
       GO TO 11
****
  13   I=I+1
       IF(I.GT.80)GO TO 19
       IF(IBUFA(I).EQ.' ')GO TO 1
       GO TO 13
****
****   END OF LITERAL FIELD DEFINED BY BLANK
****
  14   DO 15 J=L,6
          FL(J,KL)=' '
  15   CONTINUE
       GO TO 1
****
****   CONTINUATION
****
  16   IF(L.GT.1)GO TO 9
       READ(5,4000)BUFA
       I=1
       GO TO 1
****
****   FINISHED
  19   IF(ITEST.LT.0)GOTO 17
       NRI=KL+KN
       K=NRT-NRI
       IF(K.EQ.0)GOTO 17
       WRITE(6,1000)K
       GOTO 25
****
  17   IF(ITEST.LT.0)NR=NRI
       MIXUP=0
       RETURN
****   ERRORS
  20   WRITE(6,2000)
       GOTO 25
****
  22   WRITE(6,3000)
       GOTO 25
****
1000   FORMAT(' ',I2,' LAST INPUTS MISSING')
2000   FORMAT('0***TOO MANY NUMBERS GIVEN: ONLY FIRST 10 ACCEPTED')
3000   FORMAT('0***TOO MANY LITERALS GIVEN: ONLY FIRST 10 ACCEPTED')
4000   FORMAT(A80)
****
       END
